Introduction

See also Installing a Model, Selecting the current model, Running a model, Uninstalling a Model, Displaying the Model Information Pane

Welcome to Circadian Modelling Version 2.0. Circadian clocks are ubiquitous throughout nature, having been discovered in every group of organisms studied. They typically consist of gene networks made up of multiple interlocked feedback loops. Mathematical modelling provides an invaluable tool for understanding such complex systems. However, despite this enormous potential, the usefulness of modelling to the wider biological community is under exploited due to the difficulties involved for a researcher in modifying someone else's published simulations to suit their own particular research interest. We have attempted to rectify this problem and bridge the gap between theoretical and experimental biology by developing Circadian Modelling, a flexible, user-friendly software interface for running simulations.

Once the software is set up, published models can be downloaded from our website and installed. When run, the user can specify the necessary mathematical parameters, which are presented in a biologically relevant way, including the specification of complex environmental cycles, and the automated generation of mutant phenotypes. Modules allow the simulation of common circadian experimental protocols, such as a phase response curve, with just a few clicks of the mouse. Results are presented in the form of a Microsoft Excel workbook, thus the full power of Excel is available to further analyse the data.

Our principle aim is that users will be able easily ‘fine-tune’ simulations to suit their particular experimental interests. Published models can be altered in any way the user wishes, and subject to any experimental protocol that is required. In addition, we hope that the capability of our software to visualise changing levels of gene expression will prove useful in the teaching of circadian biology.

We provide on-going support and revisions in response to feedback from users and newly published models from our own and other labs, and new experimental data.

The Models

The models are made up of a series of ordinary differential equations (ODEs).

  • A model consists of a number of variables, or 'states'. The user must specify the starting value of each state, with an ODE then describing how each varies over time. Examples of states include levels of RNAs and proteins.
  • A model also contains a set of 'parameters' whose values are specified by the user. These appear as constants in the ODEs, and examples include reaction rate constants and binding constants. Manipulating parameter values can allow the simulation of mutant phenotypes.
  • Additionally, an environment must be specified under which the model is to be run. This represents the external conditions which the model is exposed to and which affects how the state levels vary over time, typically by affecting parameter values. Depending on the model, the environment consists of the light-dark cycle and/or temperature cycle. These can be manipulated to simulate a range of common circadian experiments.

Typically we supply with our models a default set of parameters and starting values which are taken from the publication.

The Main Program Window

The main window is divided into two re-sizeable panes. The left pane contains at the top, two drop-down lists. The program maintains a number of models which have been installed by the user, together with all the files associated with these which the user has created. The left hand list is a list of model groups. Selecting one of these causes the right hand list to display the currently installed models in the selected group. One of these must then be selected as the current model. Models are grouped simply to make it easier to find the required one, and can be grouped in any way the user chooses.

Below these lists a number of tabs are used to display the various files associated with the selected model.

Link to Parameters Files Link to Environment Files Link to Perturbations Files Link to Mutations Files Link to Results Files

Click on the appropriate tab to lean more about the file types.

The right pane displays information about the currently selected model..

All functions can be accessed via the menu bar, or the toolbar buttons.

Click here for a tutorial guide and begin modelling! .


Tutorial Page 1

Tutorial Page 1 The Main Program Window

Next>>

This tutorial assumes that the user has successfully installed Circadian Modelling 2.0 on a Windows PC that also has Microsoft Excel 2000 or later (but Excel 97 is probably fine too), and Internet Explorer installed. It is also assumed the the PATH variable has been successfully updated. See the Installation Guide for more information.

We will begin by running the simplest experiment, a time series where the changing level of two proteins is plotted against time.

  1. Launch Circadian Modelling. If the PATH has not been previously updated then you will be prompted to do this now and to re-boot so this change can take effect. Do this and then re-launch the program.

  2. Look at the main program window and it should look something like this.

    You will see it is divided vertically into two panes. In particular note the two drop down list boxes in the top of the left hand pane. The user interface and the models it contains are separate entities. Before you can use a model it must be installed into the interface. When you installed the program one model will have been installed by default. This is called "locke_05b" and is a model of the Arabidopsis clock developed by our lab and published in Molecular Systems Biology doi: 10.1038/msb4100018. This model has been placed in a model group called "arabidopsis". The purpose of grouping the models is to make them easier to manage and to locate the desired one. This will be especially important when a large number are installed. There is no other significance to this.

  3. Lets use this model, as at this stage it may be the only one installed. The right pane shows a graphical representation of the model equations. Click on the "Equations" tab to see the actual equations, or the "Background" tab to learn more about the model.
  4. Every simulation needs a parameters file to run. This contains values for all the constants which appear in the model equations, representing things such as reaction rate constants, together with initial values for all the model states, which are proteins, RNAs etc. Click on the "Parameters" tab of the file browser and you will see the name of the only parameters file present at this stage appear in the browser window. This is called "Default". Double click on its name to open it.

Next>>


Table of Contents

Introduction

The Menu Bar

The Toolbar

Installing a Model

Choosing a Model

Getting Information about a Model

Uninstalling a Model

Creating a Set of Parameters

Creating an Environment for the Model

Comparing Model File Contents

Defining Parameter Perturbations

Running a Simulation

Viewing Results

Generating Mutations

Comparing Experiments by Varying Parameters

Comparing Experiments by Varying Input Files

Generating a Phase Response Curve by Varying Perturbation Time

Generating a Phase Response Curve by Varying Perturbation Type

Generating a 3D Phase Response Curve

Feedback and Future Plans

Troubleshooting


Feedback and Future Plans

Future Plans

We provide on-going technical support for Circadian Modelling via our website at www.amillar.org. We would welcome any feedback or requests for improvements to our software. At present our plans for release 3.0 include the following additions:

  • The ability to use real environmental data as well as a user-defined light-dark or temperature cycle. Climatological data can be downloaded from the web and input into Circadian Modelling to see how a model would behave in a real life situation. Here is an example of some real data, downloaded from Harvard Forest.

  • The ability to visualise the time series data as the equations are solved, by the production of moving 2D and 3D graphs. This will include the ability to dynamically alter model and environmental parameters and observe the effect on the system instantaneously. We also hope that the ability to visualise the limit cycle may be useful for the teaching of circadian biology.

    Here the effect on the shape of the waveform of a change in a parameter value can be seen. This will prove useful for optimising parameters
    Here a 3D limit cycle is plotted. Compare the two cycles in LL (yellow) and DD (blue). This switch can be made dynamically when required.

  • A module to automatically find a limit cycle for a model in a particular environment. This will produce a set of initial conditions that will ensure that the model is entrained right from the start of an experiment.
  • The ability to plot simulation data alongside real experimental data.
  • We hope to make it as easy as possible for our users with Matlab programming skills to add their own models and experimental protocols.


TroubleShooting

We provide on-going technical support for Circadian Modelling via our website at www.amillar.org. We would welcome any feedback or requests for improvements to our software.

Do not attempt to edit any of the files in the Circadian Modelling Directory. Doing so will almost certainly cause errors. This does not apply of course to the Microsoft Excel workbooks created, which can be freely edited with Excel. Most errors that are likely to occur are due to installation problems.

Error | Likely Cause | Solution
Error messages about missing folders or models when starting Circadian Modelling for the first time after installing. | Circadian Modelling has been installed in the same directory as a pre-existing installation. | Re-install in an empty directory
 | There was an error during installation | Check the Installation Guide for a description of the directory structure that should have been created. Repeat installation.
Error creating folders when installing a new model | An error occurred previously when uninstalling a model in the same model group. | Follow the on-screen instructions. Re-start Circadian Modelling and try again.
 | You do not have permission to write to the folder where Circadian Modelling is installed. | Contact your system administrator.
Error editing parameters, perturbations or environment files. | You do not have permission to write to the folder where Circadian Modelling is installed. | Contact your system administrator.
Error running simulations | Your system Path variable is not set correctly. | See the Installation Guide on how to do this. Remember to re-boot after changing your Path.
 | You do not have permission to write to the folder where Circadian Modelling is installed. | Contact your system administrator.


Installing a New Model

See also Selecting a model, Uninstalling a model, Displaying the Model Information Pane

To install a new model select the Model->Install menu item, or click the corresponding toolbar button [image]. The user will then be prompted to locate the executable file representing the model. All other required files are expected to be found in the same directory in order for the installation to proceed correctly.

Next, the user is asked to specify a group to which the new model is to belong.

By selecting the appropriate option button, a pre-existing group can be selected from the list, or a new group can be created. The purpose of grouping the models is to make them easier to manage and to locate the desired one. This will be especially important when a large number are installed. Another advantage is that, although all models within a group must have unique names, multiple models with the same name can exist in different groups.

When creating a new group, the user can select an image to represent it. This will be the image appearing next to the group name in the left hand list box. It is assumed that most users will want to group models according to organism, hence a number of images are provided representing the model organisms commonly used in circadian biology. However, groups can take any name at all and some users may wish to organise their collections differently, for example, grouping models by author. This will make no difference at all to the program.

The new model is then immediately available for selection.


Choosing a Model

See also Installing a model, Uninstalling a model, Running a model, Information about the model

To select a model simply select the group to which it belongs from the left-hand list box, and then select the model from the right-hand box. The file browsers on the left pane and the model information display on the right pane are then updated to display the files associated with this model.


Displaying Information about the Model

See also Selecting a Model, Installing a Model, Uninstalling a Model

Selecting the Model->Show Details menu item, or clicking the corresponding toolbar button [image] toggles the display of the model information window in the right hand pane. This contains three tabs

  • The Picture tabs shows a graphical representation of the model equations, in the form of a flow diagram
  • The Equations tab show the differential equations which form the model
  • The Background tab displays information about the model, what it represents, and any relevant publications


Uninstalling a Model

See also Selecting a model, Installing a model, Displaying the Model Information Pane

To uninstall an existing model select the Model->Uninstall menu item. The user will then be prompted to select the name of the model to uninstall. If the Results folder for the selected model contains any files then a check box will provide the option to copy these to a separate folder before deleting the model files. If this is selected then the user is then prompted to specify a location for the backup. A new folder will be created here named Modelname_Results_Date_Time, where Modelname is the name of the model that is uninstalled.

All files and directories, including environment, parameters, perturbations, mutations, and results, relating to the selected model will then be permanently deleted. If the deleted model was the only model in its group then the group will also be deleted.


The Menu Bar

See also Toolbar

The menu hierarchy is as follows

  • File
    • New File Creates a new parameters, environment, perturbations or mutations file, depending on the selected tab on the file browser.
    • Open Opens the currently selected parameters, environment, perturbations, mutations or results file.
    • Compare Files Launches the Compare Files module, which is used for highlighting key differences between parameters, or mutations files.
    • Exit Closes the application.
  • Model
    • Show Details Toggles display of the Model Information pane
    • Install Installs a new model
    • Look for new models on the web Launches the New Models Page on the Circadian Modelling website at School of Biological Sciences, University of Edinburgh
    • Uninstall Uninstalls a model
  • Experiments
    • Time Series
      • Simple... Runs the currently selected model
      • Compare Simulations
        • Vary Parameters Freely... Compares multiple simulations, allowing the user to vary selected model and/or environmental parameters
        • Vary Input Files... Compares multiple simulations, allowing the user to vary the selected parameters, environment, and perturbations files
    • Phase Response Curve
      • Varying Time of Perturbation... Produces a PRC by applying a user-defined perturbation to model and/or environmental parameters at varying phase
      • Varying Size of Perturbation... Produces a PRC by applying a series of user-defined perturbations to model and/or environmental parameters at one phase
      • 3D... A combination of the above two., ie a series of perturbations each applied at varying phase.
  • Help
    • About Launch About Box, including copyright information relating to xml stylesheets
    • Contents Launches this help file
    • Modelling Homepage Launches the Circadian Modelling website


The Toolbar

See also Menu Bar

The functions of the toolbar buttons are as follows

Creates a new parameters, environment, perturbations or mutations file, depending on which tab is selected on the file browser.

Opens the currently selected parameter, environment, perturbations, mutations or results file.

Launches the Compare Files module

Installs a new model

Toggles display of the Model Information Pane

Runs a simple time series experiment on the currently selected model

Compares multiple simulations, allowing the user to vary selected model and/or environmental parameters

Compares multiple simulations, allowing the user to vary the selected parameters, environment, and perturbations files.

Produces a PRC by applying a user-defined perturbation to model and/or environmental parameters at varying phase

Produces a PRC by applying a series of user-defined perturbations to model and/or environmental parameters at one phase

A combination of the above two., ie a series of perturbations each applied at varying phase.

Launches this help file


Creating a Set of Parameters

See also Running a model, Environment files, Perturbations files, Mutations files, Comparing the contents of files, Comparing parameter sets

A parameters file contains values for all the constants which appear in the model equations, representing things such as reaction rate constants, together with initial values for all the model states, which are proteins, RNAs etc.. A new set of model parameters can be created in a number of ways. The quickest way is by modifying an existing set.

Opening a Parameters File

Each model comes with a default set, called “Default” which is either the published set, in the case of published models, or a set produced by an optimisation process which will produced the desired results, in the case of our own unpublished models. The default parameter set can be opened by double clicking on the file name, or by right clicking and selecting Open from the popup menu. Alternatively, select the required file name and click the File->Open menu item or press Ctrl + O.

These options open the Parameters dialog box.

This box contains a number of tabs, generally one tab corresponds to each model equation. The upper panel on each tab contains a brief description of the state which is modelled by the equation, and the lower panel contains a series of boxes in which to enter the initial value for the state, and the parameter constants required by the equation. Each box is labelled with a symbol corresponding to the symbol used in the "Equations" view of the Model Information Pane, and, in the case of published models, to those used in the publication. A short caption also explains the meaning of each parameter.

If the tab represents a gene, a check box is present between the two panels. This allows the addition of a second copy of this gene which is constitutively expressed. See generating mutations for more explanation of this.

Clicking the “Notes” button opens a simple text editor. This allows a description to be entered for the file and saved alongside the parameters set. This description can then be viewed the next time the parameters file is edited

After valid entries are made for all the boxes, the parameter set should be saved. It will then appear in the file browser.

Creating A New Parameters File

To create a new parameters set from scratch, do one of the following

  • Click on the “Parameters” tab of the file browser and then click on the File->New Parameters File menu item.
  • Press Ctrl + N when the "Parameters" tab is selected.
  • Right click on the “Parameters” view of the file browser and select New from the popup menu.

The Parameters dialog box will then be opened with empty values for each box. Valid entries must be made for all boxes before the set can be saved.

Re-naming or Deleting a Parameters File

Right click on a parameters file name. A popup menu will offer these options. However you cannot rename, delete or overwrite the default set.

Applying Mutations

A given set of mutations, which have been previously saved in mutations file, can be applied to the parameters set by clicking Mutate and selecting a mutations file from the list which appears. The controls will whose values were set by the mutation will appear with a grey background. They can however, still be changed by the user in the normal way.

For over-expresser mutants, the appropriate check box will have been selected and an extra tab inserted to represent the new gene. This will display the rate of over-expression, as set in the mutations file, and also the initial level of mRNA from this gene and the translational rate constant. These last two parameters will be the same as for the native gene by default. All other parameters concerning mRNA from this gene, such as rates of degradation, are the same as the native gene and cannot be altered for most models.

Clicking the “Notes” button will reveal that the name of the original parameters file, and all the mutations applied will have been added to the notes field. The new mutated parameters set must then be saved before the dialog box is closed.

Note that the mutated parameters will not appear in greyed boxes when the file is subsequently re-opened.

It is also possible to apply a set of mutations to a parameters file from the Mutations dialog box.


Creating an Environment for the Model

See also Running a model, Parameters files, Perturbations files, Comparing File Contents

An environment must be specified under which the model is to be run. At the minimum level, for a model which does not incorporate any external influences, the environment file can simply define how long the simulation is to be run for. However, usually the environment also represents the external conditions which the model is exposed to and which may change over time and affect how the state levels vary. In the case of most models of circadian genetic networks, external conditions consist of the light-dark cycle and/or temperature cycle. These can be manipulated to simulate a range of common circadian experiments.

Opening an Environment File

The quickest way to create a new environment file is to modify an existing one. Open an environment file by selecting the "Environment" tab on the file browser, and then double click on the file name or right click and select Open from the popup menu. Alternatively, select the required file name and click the File->Open menu item or press Ctrl + O.

These options open the Environment dialog box.

The tabs at the top of the form show which environments the current model has. In this case the model has a light-dark cycle. Other models may have a temperature cycle, in which case there will be a tab labelled "Temperature".

Light-Dark Cycle

The inner tab control has a tab labelled "Regime 1". A regime consists of a day-night cycle applied one or more times. The user defines a cycle by entering a value in the "Cycle Period" box, in this case 24 hours. The cycle is then defined as 24 hours long.

The grid below has one row for each colour of light that the current model incorporates. In this case the model has two, "Blue" and "Red". "On" and "Off" times are entered for each colour. These must be values between zero and the cycle period value. To create constant darkness for a particular colour, set the on and off values to be equal. To create constant light, set the on value to zero and the off value to the length of the cycle period. Right-clicking on the names of the colours will produce a popup menu to provide shortcuts for creating constant conditions. "Ion" and "Ioff" are the values for the light colours used in the model equations when the corresponding colour is on and off respectively.

The coloured bars provide a graphical representation of the cycle created.

Note that a regime is considered to be constant dark (DD) with respect to a particular colour only when the on and off times for that colour are equal. A regime is considered to be constant light (LL) with respect to a particular colour only when the on time is zero and the off time is equal to the cycle period for that colour. It is possible to set "Ion" and "Ioff" values to be equal, producing a constant light level throughout. However, this regime will still be considered as an LD cycle for that colour by the experimental protocols if the on and off times are not set as above.

Note that if the on time is set to zero and the off time is set to the cycle period to create LL, then even if "Ion" and "Ioff" are both set to zero the regime is still considered to be LL for that colour and not DD.

Whether a regime is considered to be LD, DD or LL for a particular colour is important when integrating model outputs against the environment cycle.

The "Select a wavelength to provide a reference for ZT0" list box allows the user to choose which colour will be used to define when ZT0 occurs. In this case, "Blue" is selected. The "On" value for this colour is zero, so a ZT0 occurs at the start of each new cycle. The large vertical marker at time zero on the graphical display indicates this. If the user had selected "Red" then ZT0 would be found 3 hours after the start of each cycle. There is also an option to select "All" from the list box. This would mean that ZT0s would be found at both times. This is not recommended however, as it would produce confusing results. If the model has only one light colour then this list will not be visible.

The times of ZT0s during the simulation are displayed in the results workbook and are important for the analyses performed. See Running a simulation.

Finally the user can enter the number of times to apply this cycle. This must be at least one. The regime is now fully defined. This is sufficient for a simulation. In the example above the simulation will last for five 24 hour days, with blue light coming on at the start of each day for nine hours, and red light coming on three hours after the start of each day for nine hours.

Sometimes. however, the user will wish to change the environmental cycle during the simulation. For example, running a model for a number of days at one photoperiod, then switching to another, or entraining a system to a cycle, and then switching to free running in constant conditions. For this reason it is possible for the user to define as many regimes as they wish. Clicking on the Insert button adds a new regime immediately after the selected one, with the controls set to default values. Clicking on Insert copy adds a new regime immediately after the selected one which is a copy of the selected regime. Clicking on the Delete button deletes the selected regime. During the simulation the regimes are applied in the order in which they appear in the tabs list.

Temperature Cycle

If a model includes temperature as an environmental factor then the "Temperature" tab will be present

These controls work in exactly the same way as the light-dark controls, except that there is only ever a single row in the input grid. "Ton" and "Toff" refer to the values used in the equations during periods of high and low temperature respectively. "On" refers to the time when temperature switches to its high value, and "Off" refers to the time when it switches to the low value. Instead of the list box a check box is present asking the user whether temperature should be used as a zeitgeber. If so then the "On" value is used to define ZT0. For models which have no light-dark cycle then this box is not show as in this case temperature must be used.

The times of ZT0s during the simulation are displayed in the results workbook and are important for the analyses performed. See Running a simulation.

.

Note that a regime is considered to be constant low temperature only when the on and off times are equal. A regime is considered to be constant high temperature only when the on time is zero and the off time is equal to the cycle period. It is possible to set "Ton" and "Toff" values to be equal, producing a constant temperature throughout. However, this regime will still be considered as a high-low cycle by the experimental protocols if the on and off times are not set as above.

Whether a regime is considered to be constant high or low temperature or a high-low cycle is important when integrating model outputs against the environment cycle.

Note that if a model has both a light-dark and a temperature cycle, then these are not constrained to be the same length. If they are not then when the file is used in a simulation the shorter of the two is extended to match the longer. This is done as follows. Any light colour set to LL will have its "Ion" value extrapolated forward. Any light colour set to LD or DD will have its "Ioff" value extrapolated. Temperature is treated in the same way, ie if set to constant high temperature then the "Ton" value will be extrapolated, otherwise, it will be the "Toff" value.

Clicking the “Notes” button opens a simple text editor. This allows a description to be entered for the file and saved alongside the environment values.

The file should now be saved, and will appear in the file browser.

Creating a New Environment File

To create a new environment file from scratch do one of the following

  • Click on the “Environment” tab of the file browser and then click on the File->New Environment File menu item.
  • Press Ctrl + N when the "Environment" tab is selected.
  • Right click on the “Environment” view of the file browser and select New from the popup menu.

These options open the Environment dialog box with the controls set to default values.

Deleting or Re-naming an Environment File

Right click on a file name in the “Environment” view of the file browser. A popup menu will appear with these options.


Parameter Perturbations

See also Running a model, Environment files, Parameters files, Mutations files

Parameter perturbations are a set of perturbations that can be applied to any of the model parameters or state variables at specified times during a simulation. Examples of when this might be useful could include

  • Simulating an over-expresser gene. Such a gene can be added to a parameters file with a defined level of transcription. However, the user may not wish this gene to be switched on the whole time, they may wish it to be activated half way through the simulation. To achieve this its transcription level could be set to zero in the parameters file, and then a perturbations file could be used to perturb its value to the desired level at a specified time from the start of the simulation.
  • Entraining a system to a regular change other than the environment cycle, for example a repeated change to a model parameter.

To create a perturbations file do one of the following:

  • Click on the “Perturbations” tab of the file browser and then click on the File->New Perturbations File menu item.
  • Press Ctrl + N when the "Perturbations" tab is selected.
  • Right click on the “Perturbations” view of the file browser and select New from the popup menu.

Alternatively, an existing file can be opened by double clicking on the file name, by right clicking and selecting Open from the popup menu, or by selecting the required file name and clicking the File->Open menu item or pressing Ctrl + O.

These options open the Perturbations dialog box.

The form contains two tabs, one for state perturbations, and one for parameter perturbations.

Model State Perturbations

A state perturbation is an instantaneous change applied to a model state at a particular time. Firstly, select the state to be perturbed from the list box at the top of the form. In this case the level of LHY mRNA is selected. The size of the perturbation is defined using the controls below:

  1. Selecting "Setting to" means that when the perturbation is applied, it will change the state value to the number in the box, whatever its value happens to be at the time.
  2. Selecting "Multiplying by" will multiply the current state value by the number in the box.
  3. Selecting "Adding" will add the number in the box to the current state value.
Note that, although it is possible to enter a negative number to add to the state value, a state value may not fall below zero. If the perturbation would result in this happening, then the state value is simply set to zero.

Model Parameter Perturbations

A parameter perturbation is a change applied to a model parameter at a particular time and for a defined length of time. Firstly, select the parameter to be perturbed from the list box at the top of the form. The size of the perturbation is then defined in the same way as for states except that an extra box exists to enter the length of the perturbation.

Perturbation Times

Perturbation times are not defined directly in a perturbations file, but rather are defined relative to the environment file with which they will be combined when the simulation is run. For models with an external environment this is done using the controls below:

In this example a perturbation will be applied 12 hours after the start of cycle number five of the first regime of the light-dark cycle. This allows the user to re-use a single perturbations file to apply a perturbation at the same time relative to the time of day for a number of environment files. This is particularly useful for applying a repeated perturbation as it avoids having to re-calculate the times when changing the environment.

For models with no external environment, the user simply enters a time from the start of the simulation.

Repeats of a perturbation are applied using the controls below:

Repeats are activated by checking the box.

  1. Selecting "hours intervals" will apply the repeat at interval of the value in the box, in this case 24, regardless of the environment file.
  2. Selecting "same time in subsequent LD cycles" will apply a repeat at the same number of hours into each subsequent cycle, regardless of the light "On" and "Off" times.
  3. Selecting "same light-dark ZT time" will calculate the ZT time of the first perturbation and apply a repeat each time this ZT time recurs. This option is different from 2. as in this case the time of the repeats will be affected by any changes in light "On" times in later regimes, as these will affect the ZT time. Note however, that sometimes it is not possible to assign a ZT time to the first perturbation, for example if it occurs before the first ZT0, and in this case no repeats will be applied.
Note
  • Had the user defined the first perturbation relative to the Temperature Cycle, then repeats would then be defined relative to this cycle rather than the light-dark cycle.
  • For models with no external environment, only option 1. is available.

The total number of repeats to be applied, not including the first perturbation is defined in the right-hand box. This number will be applied if the environment file is long enough, otherwise as many as possible will be applied.

When a perturbation is fully defined, click the "Add" button to add it to the grid in the lower half of the form. Perturbations can be removed from the grid by selecting them and clicking "Remove".

Clicking the “Notes” button opens a simple text editor. This allows a description to be entered for the file and saved alongside the parameters set. This description can then be viewed the next time the parameters file is edited

When the file is complete, clicking "Save" will write the contents of the grids to file. The new file then appears in the file browser.

Re-naming or Deleting a Perturbations File

Right click on a perturbations file name. A popup menu will offer these options.


Generating Mutations

See also Parameters files, Comparing the contents of files

Mutant phenotypes can be simulated by setting the appropriate parameter values. For example, setting a maximum transcription rate to zero in order to simulate a knockout mutation. Additional copies of a gene, which will be constitutively expressed, can be added by selecting the check boxes on the appropriate tab on the Parameters Form. However, Circadian Modelling provides a number of pre-defined mutations for each model to greatly simplify this process. These can be created and viewed as follows.

Click the “Mutations” tab on the file browser to view the mutations files. If there are no mutations files present, then one can be created by clicking the File->New Mutation menu item, by pressing Ctrl + N, or by right clicking on the browser and selecting New from the popup menu.

Alternatively, a pre-existing file can be opened by selecting it and clicking the File->Open menu item, or pressing Ctrl + O, or by double clicking on the file name, or right clicking and selecting Open from the popup menu.

Any of these actions will launch the Mutations dialogue box.

This contains a number of tabs, representing targets for mutation for the selected model. These will generally be entities such as gene promoters, or proteins. On each tab will be the list of predefined mutations available for that target. To activate one simply select the corresponding check box.

Mutations involving the addition of a second copy of a gene, to be constitutively expressed, also require that the rate of expression be entered. In order to get a reasonable idea of what value this should be set to, it is advisable to run the un-mutated parameter set and note the maximum rate of expression of the native gene.

Constitutive over-expresser mutations create a pool of mRNA which is separate from that produced by the native gene, and result in an extra set of outputs concerning this pool becoming available when the simulation is run. The two pools of mRNA are translated independently, but the protein produced is pooled. This is done so that the native gene can be mutated independently of the over-expresser. For example, the translation of its mRNA can be set to zero to create a protein null mutant, in order to observe the effect of a constant high level of protein produced by the over-expressing gene.

Clicking “Save” will now create a new mutations file which will be added to the file browser. Such files consist simply of the combination of check boxes that were set, together with any other values entered. Their purpose is to allow a complex set of mutations to applied repeatedly to more than one parameters set. Right-clicking on a file name will produce a popup menu that allows files to be renamed or deleted.

Applying Mutations

A given set of mutations are applied to a given parameters file by clicking Apply and selected a parameters file from the list which appears. This is equivalent to choosing a genetic backgound in which the mutation will be found. This launches the Parameters dialog box. The controls will contain all the values from the specified parameters set, other than those which were set by the mutation. These boxes will appear with a grey background. They can however, still be changed by the user in the normal way.

For over-expresser mutants, the appropriate check box will have been selected and an extra tab inserted to represent the new gene. This will display the rate of over-expression, as set in the mutations file, and also the initial level of mRNA from this gene and the translational rate constant. These last two parameters will be the same as for the native gene by default. All other parameters concerning mRNA from this gene, such as rates of degradation, are the same as the native gene and cannot be altered for most models.

Clicking the “Notes” button will reveal that the name of the original parameters file, and all the mutations applied will have been added to the notes field. The new mutated parameters set must then be saved before the dialog box is closed.

Note
  • The mutated parameters will not appear in greyed boxes when the file is subsequently re-opened.
  • It is not necessary to save a set of mutations before applying them to a parameters set.

It is also possible to apply a set of mutations to a parameters file from the Parameters dialog box.


Comparing the Contents of Model Files

See also Parameters files, Mutations files

The Compare File Contents module allows the contents of selected parameters, or mutations files to be rapidly displayed at the same time and compared. This is useful for picking out key differences between complex files, for example, finding the differences between parameters files representing a wild type and a mutant.

To activate this module, click the File->Compare Files... menu item, click the corresponding toolbar button [image], or press Ctrl + C. This should launch the Compare Files window below

The form is used as follows:

  1. Select the type of files to compare using the option buttons
  2. Select the files to include from the list of those available for the current model
  3. Click "Compare" to produce a table of results. In this table each row represents a file entry, and each column a file, as determined by the titles in the first row and column.
    • For parameters files parameters are grouped according to the way they are grouped by tabs on the parameters dialogue box, ie generally by equation. Group titles are listed in bold font, and under each appears, in normal font and indented, each parameter from that group which did not have identical values in each file selected, together with the actual values from each file. An example can be seen above, where file "lhy_OX" contains an over-expresser gene called "LHY OX", resulting in the addition of three extra parameters not found in the other files. The file "TOC1_KO" has the TOC1 gene knocked out, hence the appropriate values are set to zero in this file.
    • For mutation files all available mutations are listed, grouped under titles in bold font. Any mutations present in a particular file will be marked with a [image], except for mutations such as over-expresser genes which require the user to enter a parameter. In these cases the actual parameter in the file will appear.

Clicking the "Export Grid" button will copy the results table to a Microsoft Excel workbook, for formatting and printing.

The Compare File Contents dialog box can remain open in the background when the user wishes to return to the main interface. However, if a different model is selected then the contents of the results table are lost.


Running a Simulation

Running a Time Series Simulation

See also Parameter files, Environment files, Generating mutations, Parameter perturbations, Viewing results

The simplest experiment is a simple time series where the simulation is run once and the required outputs are plotted against time. All simulations require a Parameters file and an Environment file to be created. Optionally, a Perturbations file can also be used. After the required files have been created, the simulation is activated by clicking the Experiments->Time Series->Simple... menu item, or by clicking on the toolbar button [image], or pressing Ctrl + S.

Required Input

The user must then navigate through a series of form that collect the required input. Values already entered can be changed at any time by clicking the "Back" button. The first form is show below:

A parameters file and an environment file must be selected from the drop-down lists of available sets. Alternatively, new ones can be created by clicking the "New" button to activate the appropriate dialog box. A name under which the generated Microsoft Excel workbook will be saved must then be entered. Note that the “.xls” extension is not required.

Clicking “Next” brings up the form below. The user can select a perturbations file from the list. When this is done, the perturbations in this file are applied to the selected environment file to create the actual times when they will be applied. See the section on the Perturbations Dialog box to learn more about this. These times are then displayed in the grids for states and parameters.

Note some perturbations may be illegal for the selected Parameters file or Environment file. The user is warned of any illegal perturbations when a Perturbations file is selected and these are automatically not applied.
  • The calculated time values may be out of range for some Environment files.
  • Some parameter perturbations involving adding values to the value from the parameters file may not be possible for every file if the resulting value is invalid for that parameter. However, only individual perturbations are validated. If two valid perturbations acting on the same parameter overlap, then the second perturbation acting on the result of the first may produce a invalid nonsensical value when the simulation is run. For example, a reaction rate constant may be set to a negative value. Very rarely this may cause the simulation to crash.

The changing values of any parameters that are subject to perturbations are plotted in the results workbook so the user can see exactly where they were changed, and to what value.

Perturbations files are optional. If one is not required, then simply select "-none-" from the list. This is the default state.

Clicking "Next" produces the form below:

The user must select which model outputs they wish to appear in the results workbook These correspond to the outputs listed after the model equations on the Model Information Pane. Outputs generally consist of the changing levels of the model states (generally in nM), and various instantaneous rates of change (generally in nM/h) which can be calculated. Rates consist of such things as the rate of expression of a gene, or the rate of degradation of a protein. The required outputs can be selected by checking the appropriate box. The "Select output group" list box simply applies a filter to which outputs are displayed, making the required ones easier to find in, especially for complex models.

The workbook produced will contain a worksheet for each selected output. A chart will also be produced for each, plotting each of these versus time, unless the “Plot all on same axes” check box is selected, in which case all outputs will appear on the one chart.

Note that if the selected parameters file contains an over-expressor gene, then outputs relating to this will be present. Typically these will include the level of mRNA from this gene, the rate of transcription of the gene, and the rates of translation and degradation of the mRNA from the gene. These will be clearly labelled as belonging to the over-expressor gene and will generally appear at the end of the list of all outputs, and will have their own filter. They should not the confused with the corresponding outputs for the native gene, which will still be present even if it is knocked out.

Clicking "Next" again then displays the integration options box.

Integrating a model state means measuring the area under the curve of its time series plot over a defined range of time values. This then gives a measure of the total amount present during the time range. The purpose of integration is to allow the user to investigate coincidences between states and the environment cycle, for example day time and night time, and between two or more states, for example, the overlap in existence of two proteins. This can answer questions such as "What amount of Protein A is produced during the hours of darkness?", and "What proportion of Protein A is produced when Protein B is present?".

The drop-down list at the top of the form contains a list of all model states that were selected as outputs. To choose to integrate one, select it and then check the box next to its name, as above. Doing this activates the "Measure coincidence with" controls. Their purpose is twofold.

  1. To define the separate time blocks that should be integrated. Under "Environment cycle:" are listed all the environmental components of the current model. In this case the model has only one light colour, and no temperature cycle. Checking the box to integrate against one or more light colours will result in integration values being produced as follows

    • For light-dark regimes with periods each cycle where all selected lights are on, ie "days" and periods where at least one is off, ie "nights", integration values are produced for each day and night.

      In this example of a model with multiple light inputs, if the user elected to integrate against all three colours then this regime would be considered an LD cycle. This is because all three overlap between 12 and 18 hours, so this part of the cycle would represent the "day".

    • Light-dark regimes were the "On" time for all selected light colours is set to zero and the "Off" time for all selected colours is set to the cycle period. ie all are LL, are considered to represent constant light with respect to the selected colours. Light-dark regimes where there is no time where all selected colours are on together are considered to represent constant dark with respect to the combined colours (this is case even though most of the colours could be on for most of the time). In these cases then time blocks are created by dividing the time series up according its free running cycle period under these conditions.

      In this example the regime would be considered to be LL as all three colours are LL individually.
      In this example if the user elected to integrate against all three colours then the regime would be considered to be DD as there is no period where all three colours are on simultaneously, even though none are DD individually.

    Integrating against temperature will produce similar results using the high and low temperature values for days and nights respectively. For models with both light-dark and temperature cycles, choosing to integrate against both light and temperature will produce two independent sets of results for each.

    If the user elects not to integrate against any environmental component then the entire time series is divided up into free running cycle periods. It is the period nearest the block in question that is used in each case.

  2. To allow the user to elect to integrate the area under the curve of a state only where it coincides with the presence of another state, ie the area where the two curves overlap. Under "Other selected outputs:" are listed all the other states selected as outputs. Check the relevant boxes to measure the overlap.

To avoid any ambiguity, the results workbook created will display the values which were used for integration. Examples are shown in the Results section below.

Warning: selecting lots of outputs to integrate can add considerably to the time taken to complete the simulation.

Clicking “Finish” will then start the simulation. A progress bar will appear informing the user as each stage of the generation of the workbook is completed. On completion a check box provides the option to automatically open the workbook just created, which will now appear in the results view of the file browser.

Results

The first worksheet in the workbook is named “Title”. This describes exactly what the results represent, and contains details such as the name of the model, the date and time it was run, all the files selected and their contents. Parameters are listed in groups corresponding to the tabs on the parameters dialog box. Thus a complete definition of the experiment is created, allowing it to be re-produced exactly.

The next worksheet is called “Environment”. This contains a column of time values (column A), and, if the model has them, corresponding values for light colours and temperature (columns C onwards).

Note the precise time values at which the changing model outputs were evaluated will vary between experiments, and are simply those determined by the ODE solver to provide the necessary degree of accuracy. However, it should be noted that they are not evenly spaced values, and so model outputs should always be plotted as an XY type scatter plot. The Excel line graph option will display all time points equally spaced along the X axis, distorting the data.

If the model has a light-dark or a temperature cycle, then next to these values will be a table displaying all the times of ZT0s that occurred during the simulation, as defined by the environment cycle. For models with both cycles, these will be labelled "LD" or "TEMP" according to which cycle produced them. For example, the table below was produced by an LD cycle of period 24 hours with lights on at time zero which was repeated 5 times. A switch was them made to DD after 120 hours, hence the missing ZT0s at 120, 144... Lights came on again for the final time at 240 hours.

The values in this table are used to assign a ZT time to each time point in column A. These appear in column B.

A table of "On" and "Off" values is then displayed for each environmental component. For any regime of constant conditions which follows a regime with an on-off cycle, predicted on and off times will appear in grey. For example in the table below a 12:12 LD cycle was repeated 5 times. A switch was then made to DD for 5 day, hence the predicted on and off times from 120 to 228 hours in grey. A final switch was then made to LL, hence a "real" on time at 240 hours in black.

If any parameters were perturbed during the simulation, then the next two sheets will be a chart called "Chart - Parameter Perturbations", and a worksheet of the source data called "Parameter Perturbations". The chart displays the values of any perturbed parameters plotted alongside the environment cycle. For example, in the chart below the user elected to perturb the parameter q1 briefly at dawn on days two to five.

Note that the environment is plotted on a secondary y-axis which is hidden from view. The graph displays its relative changing value rather than its absolute value.

A number of other worksheets and charts will then be found, one set for each output.

  • There will be worksheet named after the output. This contains the time series data, together with the ZT time of each time point, in columns A to C. Next to this in columns E onwards, will be tables for peak and trough values. The left-most columns indicate which light-dark or temperature regime each peak fell in if applicable. The entries in these cells take the form "REG regime number, CP cycle number". Then are columns of peak and trough times and sizes. Several other columns of analysis then follow these:

    • The column “Cycle Period” represents the time difference between each peak/trough and the previous one.

      Note it is sometimes noticed that different selected outputs can have slightly different values for cycle period. If this is the case then it is either due to numerical error in the equation solver, or is caused by the model not having reached a limit cycle.

      Note that some outputs of some models may have complex waveforms, for example biphasic peaks. If multiple peaks and troughs are found in each cycle period then period values will reflect the inter-peak interval rather than the true cycle period. At present there is no way around this problem.

    • “ZT Time” represents the ZT time of each peak or trough. It can be seen from the formulae used in the cells that this is calculated simply by subtracting from the peak/trough time the time of the previous ZT0
    • “CT time” represents the Circadian Time, and is only filled in for regimes of constant conditions. Circadian time is calculated as follows:
      • Take the previous ZT0. This is defined as CT0.
      • If this peak/trough is not the first within the present regime of constant conditions, then extrapolate the CT0 time forward using the free running cycle period at the previous peaks in constant conditions. This then gives the last CT0 before the peak in question.

      • Convert the time between this CT0 and the peak in question to circadian hours by multiplying it by 24 dividing by the free running cycle period at this peak.

        Note that if the peaks are far from being evenly spaced, say for example when an erroneous peak appears because the model is far from being entrained, or there is some sort of perturbation, then this extrapolation technique can produce a value outside the range 0 to 24, due to the free running cycle period being distorted, generally shortened. In this case modulo 24 is applied to give a value within the appropriate range. This effectively extrapolates the erroneous cycle period back in time. Discarding an initial period of the time series data (see above) can also cause modulo 24 to be applied to a particular peak or trough CT time, if within the discarded data are peaks or troughs that occurred since the last ZT0. This would make it impossible to extrapolate CT0 forward due to the missing cycle periods. Applying modulo 24 effectively applies the present cycle period over the missing time block. This will of course give a slightly different answer than if all the time series data was retained, unless the model is perfectly entrained and the cycle period does not vary.

    The Cycle Periods, ZT and CT times calculated are expressed as Excel formulae, rather than literal values, thus the user can see exactly how they were calculated, and can alter this if required.

    Note that the columns “ZT Time” and “CT Time” will be missing if the model does not have a light-dark or a temperature cycle. They will be empty if the selected environment consisted only of constant dark, or constant low temperature. This is because in both cases there is no reference for calculating ZT time.

    If the output was integrated then the results will appear below these tables. An example is shown below

    In this example, the user elected to integrate the output cLm, measuring its overlap with the output cTM, against white light. The top half of the table shows time blocks for each day and night for a 12:12 LD cycle (0 to 120 hours). The lower half of the table shows time blocks of one free running cycle period during constant dark (120 to 240 hours, right half), and constant light (240 to 360 hours, left half). If an output is not integrated against either the light-dark or the temperature cycle, then the results appear under the heading "Cycle Periods".

    In order to remove any ambiguity, the exact figures that were used for integration are then displayed to the user. These appear in a column called "Values used for integration", and are plotted on an embedded chart, an example of which is shown below.

    Here Level of LHY mRNA is the output being integrated. Its overlap with Level of TOC1 mRNA is being measured. This is represented by the thick black line. The markers [image] represent the boundaries of the time blocks from the table above. As can be see, for the first 120 hours these coincide with the light-dark cycle, then they represent free running cycle periods. If the output is integrated against the temperature cycle, then the markers for these boundaries are red. Any time point that is used for both cycles will be in pink. If the output is integrated against neither cycle, then the markers will be cyan in colour.

    Note that the environment is plotted on a secondary y-axis which is hidden from view. The graph displays its relative changing value rather than its absolute value.
    • If any values for Circadian Time were calculated for any of the peak times, then these will be plotted against peak number on a chart called "Chart - output name Peaks". This is so it is possible to track any changes in CT time, as a change in the time of the peak's position within a free running period may indicate a change in the shape of the waveform.
      • If no CT values were calculated then this chart will not be present.

    • There will be chart called "Chart - output name" which will be the time series for this output plotted alongside any environment cycle.

      Note that if the user elected to plot all outputs on same axes, then the above two charts will not be present, but there will be a single example of each at the end of the workbook containing data from all the selected outputs.

    Finally, for some models there may be one or more extra worksheets of analysis present. This will generally be the case if the model was developed with a specific aim in mind requiring model-specific processing of the data to be carried out. An example of this is our model of the Arabidopsis circadian clock which was developed to measure the effect of photoperiod on induction of flowering, shortly to be available from our website. This model produces an extra table of data showing photoperiod versus percentage flower induction.


Viewing Results

Results are created in the form of a Microsoft Excel workbook. Thus they are completely independent files which can be viewed, manipulated and saved using all the power of Microsoft Excel, completely separate from Circadian Modelling. Our program does however provide a file browser for viewing the saved workbooks for the current model. This can be viewed by selecting the “Results” tab.

A workbook can be opened from the browser in several ways

  • By selecting the required file and clicking the File->Open menu item or pressing Ctrl + O
  • By right clicking the file and selecting Open from the popup menu.
  • By double clicking on the required file.
  • By clicking the toolbar button [image] when the file is selected.

Workbooks can also be opened automatically at the end of a simulation by ensuring the check box on the progress bar is selected.

Workbooks can also be renamed and deleted using the popup menu.


Varying Model Parameters

Comparing Multiple Simulations, varying Model and Environmental Parameters

See also: Running a Simple Time Series, Comparing Multiple Simulations, varying Model and Environmental Files

This experiment allows the user to select a parameters file , environment file, and optionally, a perturbations file, to run a time series experiment a defined number of times. Selected parameters from these files can be varied between runs in any way and in any combination the user wishes. Corresponding outputs for each run are compared and plotted on the same axes. Possible uses for this module include comparing a mutation to the wild type, or comparing the same model in different environments, such as a fluence response experiment or a photoperiod experiment. If a large number of parameter differences are required between runs then it may be simpler to use the Vary Files experiment.

To run this experiment, first select the Experiments->Time Series->Compare Simulations->Vary Parameters Freely menu item, click the corresponding toolbar button [image], or press Ctrl + R.

Required Input

The user must then navigate through a series of forms that collect the required input. Values already entered can be changed at any time by clicking the "Back" button. The first form is show below:

A parameters file and an environment file must be selected from the drop-down lists of available sets. The selected files can be viewed and edited by clicking the "Edit" button to activate the appropriate dialog box. A name under which the generated Microsoft Excel workbook will be saved must then be entered. Note that the “.xls” extension is not required.

Clicking “Next” brings up the form below. Here the user can select the parameters which are to be varied between runs. If the model has an external environment, the "Environment" tab will display a list of all the environment parameters which can be varied. These can include all the parameters which characterise a light-dark or a temperature regime, such as cycle period, on and off times, and high and low values. See Environment files for an explanation of how an environment is defined. The "Parameters" tab displays a list of all the model parameters. Select any that are to be varied by checking the appropriate box.

In the example above the user has chosen to vary the time that White light goes off, ie the time of dusk. This could be used to investigate the effect of changing day length on a model.

Clicking "Next" brings up the form below. All the model and environment parameters selected will now appear in the data grid under the appropriate tab.

The first column contains the names of the selected parameters, and the second column "Default" contains their values from the selected Environment or Parameters file. The number of columns headed "Value X" determine how many times the simulation will be repeated. Clicking "Add a new set of values" will add another column to both grids. The user can enter values in these columns that set the value that the parameter will take on that particular run. It is not necessary to enter values for each parameter for all runs. If no value is entered then the parameter takes its default value for that run. In the example above the parameter m1 takes the values 2.0 and 3.0 on the first and second runs respectively, and the parameter p2 is set to zero for the first run, but keeps its default value of 4.324 on the second run.

On the next form the user may optionally select a perturbations file from the list. When this is done, the perturbations in this file are applied to the selected environment parameters to create the actual times when they will be applied. These times may vary between runs if the environment parameters vary, for example, if a perturbation is applied at a specified ZT time, then if daylength is varied between runs then this could be affected. See the section on the Perturbations Dialog box to learn more about how perturbation times are defined. For this reason perturbations are calculated separately for each run. Use the drop down list below the grid to display the perturbation times on each run in the grids for states and parameters. In the example below, if perturbations file "g1" is selected, then in the first run parameter g1 will be doubled for three hours at zero hours and 24 hours.

Clicking the "Edit" button allows the user to view and change the contents of the selected file.

Note some perturbations may be illegal for the selected model or environmental parameters for a particular run. The user is warned of any illegal perturbations for each run when a Perturbations file is selected and these are automatically not applied.
  • The calculated time values may be out of range for some Environment files, or any alternative simulation length defined as above.
  • Some parameter perturbations involving adding values to the value from the parameters file or any alternative value defined as above may not be possible if the resulting value is invalid for that parameter. However, only individual perturbations are validated. If two valid perturbations acting on the same parameter overlap, then the second perturbation acting on the result of the first may produce a invalid nonsensical value when the simulation is run. For example, a reaction rate constant may be set to a negative value. Very rarely this may cause the simulation to crash.

The changing values of any parameters that are subject to perturbations are plotted in the results workbook for each run so the user can see exactly where they were changed, and to what value.

Perturbations files are optional. If one is not required, then simply select "-none-" from the list. This is the default state.

Clicking "Next" produces the form below.

The user must select which model outputs they wish to appear in the results workbook These correspond to the outputs listed after the model equations on the Model Information Pane. Outputs generally consist of the changing levels of the model states (generally in nM), and various instantaneous rates of change (generally in nM/h) which can be calculated. Rates consist of such things as the rate of expression of a gene, or the rate of degradation of a protein. The required outputs can be selected by checking the appropriate box. The "Select output group" list box simply applies a filter to which outputs are displayed, making the required ones easier to find in, especially for complex models. The workbook produced will contain a worksheet for each selected output for each run.

Note that if the selected parameters file contains an over-expressor gene, then outputs relating to this will be present. Typically these will include the level of mRNA from this gene, the rate of transcription of the gene, and the rates of translation and degradation of the mRNA from the gene. These will be clearly labelled as belonging to the over-expressor gene and will generally appear at the end of the list of all outputs, and will have their own filter. They should not the confused with the corresponding outputs for the native gene, which will still be present even if it is knocked out.

The workbook will also contain summary tables and charts for each output. These show the effect of parameter values on features of the output such as phase and cycle period. Checking the "Plot summary information on same axes" box will cause a single summary chart for each feature to be produced, with all selected outputs plotted on the same axes (see Results section below).

If the "Retain the times series data" box is unchecked, then the results workbook will contain just the summary information and charts, greatly reducing its size. Alternately, leaving this box checked and entering a value in the box will cause an initial period of the time series data to be discarded, the rest being retained.

Clicking "Next" again then displays the integration options box.

Integrating a model state means measuring the area under the curve of its time series plot over a defined range of time values. This then gives a measure of the total amount present during the time range. The purpose of integration is to allow the user to investigate coincidences between states and the environment cycle, for example day time and night time, and between two or more states, for example, the overlap in existence of two proteins. This can answer questions such as "What amount of Protein A is produced during the hours of darkness?", and "What proportion of Protein A is produced when Protein B is present?".

The drop-down list at the top of the form contains a list of all model states that were selected as outputs. To choose to integrate one, select it and then check the box next to its name, as above. Doing this activates the "Measure coincidence with" controls. Their purpose is twofold.

  1. To define the separate time blocks that should be integrated. Under "Environment cycle:" are listed all the environmental components of the current model. In this case the model has only one light colour, and no temperature cycle. Checking the box to integrate against one or more light colours will result in integration values being produced as follows
    • For light-dark regimes with periods each cycle where all selected lights are on, ie "days" and periods where at least one is off, ie "nights", integration values are produced for each day and night.
    • For light-dark regimes were all selected light colours are on throughout the cycle (LL), or where there is no time where all are on (DD, with respect to the combined colours), time blocks are created by dividing the time series up according its free running cycle period under these conditions.

    Integrating against temperature will produce similar results using the high and low temperature values for days and nights respectively. For models with both light-dark and temperature cycles, choosing to integrate against both light and temperature will produce two independent sets of results for each.

    If the user elects not to integrate against any environmental component then the entire time series is divided up into free running cycle periods. It is the period nearest the block in question that is used in each case.

  2. To allow the user to elect to integrate the area under the curve of a state only where it coincides with the presence of another state, ie the area where the two curves overlap. Under "Other selected outputs:" are listed all the other states selected as outputs. Check the relevant boxes to measure the overlap.

To avoid any ambiguity, the results workbook created will display the values which were used for integration. Examples are shown in the Results section below.

The integrated areas measured will appear as part of the summary information. This is particularly useful, if for example, the user wished to perform a photoperiod experiment and look at the effect of varying the light-dark cycle on the coincidence between light and one of the outputs.

Warning: selecting lots of outputs to integrate can add considerably to the time taken to complete the simulation.

Clicking “Finish” will then start the simulation. A progress bar will appear informing the user as each stage of the generation of the workbook is completed. On completion a check box provides the option to automatically open the workbook just created, which will now appear in the results view of the file browser.

Results

On completion of the simulation a check box provides the option to automatically open the workbook just created, which will now appear in the results view of the file browser.

The first worksheet in the workbook is named “Title”. This describes exactly what the results represent, and contains details such as the name of the model, the date and time it was run, all the files selected and their contents. Parameters are listed in groups corresponding to the tabs on the parameters dialog box. Below the file information comes a table which shows how parameters were varied between runs from their default values in the files. Thus a complete definition of the experiment is created, allowing it to be re-produced exactly.

The next worksheet is called "Summary Data". It contains a series of tables, one for each selected output, which displays the how the values of various features of the output vary between runs. An example is shown below:

Here one parameter, Off time of White light, is varied between runs. If the user elected to retain the time series data, then all values in this table are formulae referencing cells on the appropriate time series sheets. Thus the user can see exactly how each was calculated, and can change this if required. Period is the last measured peak to peak interval for the output. Amplitude is the last measured peak size minus the last measured trough size. Phase values are those for the last peak and trough. CT values are used if present, otherwise ZT values are used.

Note it is sometimes noticed that different selected outputs can have slightly different values for cycle period. If this is the case then it is either due to numerical error in the equation solver, or is caused by the model not having reached a limit cycle.

Note that some outputs of some models may have complex waveforms, for example biphasic peaks. If multiple peaks and troughs are found in each cycle period then as cycle period and amplitude values are calculated using the final peaks and troughs and inter-peak interval, then their values will depend on the phase the model was in when the simulation ended, and will therefore be misleading. At present there is no way around this problem. If unexpected results are found then the user should check the time series plots to ensure that this is not the case.

Note that if the model does not have an external environment, then the phase columns will not be present.

If any integration options were selected, then these values appear next.

The next worksheet is called "Summary Charts". It contains a series of charts for each of the data columns above. If the user elected not to plot summary information on the same axes (see above), then there will be a row of charts for each output.

In this example, the user elected to vary only one parameter, Off time of White light, and therefore the daylength is varied from 4 to 20 hours in a 24 hour cycle. The graph is an XY plot of coincidence of the selected output versus daylength.
In this example, the user elected to vary more than one parameter. Therefore in this case the chart is a line plot, with each run considered by Excel to be a category, rather than a value. This means that all points will be equally spaced regardless of the value of any parameter set by each run. Categories are named after the parameter values which are set by that run, and which appear in the summary table.

Next come a set of worksheets for each simulation run.

  1. The first in each set is called "Environment X", where X is the run number. This contains a column of time values (column A), and, if the model has them, corresponding values for light colours and temperature (columns C onwards).

    Note the precise time values at which the changing model outputs were evaluated will vary between experiments, and are simply those determined by the ODE solver to provide the necessary degree of accuracy. However, it should be noted that they are not evenly spaced values, and so model outputs should always be plotted as an XY type scatter plot. The Excel line graph option will display all time points equally spaced along the X axis, distorting the data.

    If the model has a light-dark or a temperature cycle, then next to these values will be a table displaying all the times of ZT0s that occurred during the simulation, as defined by the environment cycle. For those models which have both cycles, these will be labelled "LD" or "TEMP" according to which cycle produced them. For example, the table below was produced by an LD cycle of period 24 hours with lights on at time zero which was repeated 5 times. A switch was them made to DD after 120 hours, hence the missing ZT0s at 120, 144... Lights came on again for the final time at 240 hours.

    The values in this table are used to assign a ZT time to each time point in column A. These appear in column B.

    A table of "On" and "Off" values is then displayed for each environmental component. For any regime of constant conditions which follows a regime with an on-off cycle, predicted on and off times will appear in grey. For example in the table below a 12:12 LD cycle was repeated 5 times. A switch was then made to DD for 5 day, hence the predicted on and off times from 120 to 228 hours in grey. A final switch was then made to LL, hence a "real" on time at 240 hours in black.

  2. Next will be a series of worksheets called "Output name, Run X", one set for each selected output. These contain the time series data, together with the ZT time of each time point, in columns A to C. Next to this in columns E onwards, will be tables for peak and trough values. The left-most columns indicate which light-dark or temperature regime each peak fell in if applicable. The entries in these cells take the form "REG regime number, CP cycle number". Then are columns of peak and trough times and sizes. Several other columns of analysis then follow these:

    • The column “Cycle Period” represents the time difference between each peak/trough and the previous one.

      Note it is sometimes noticed that different selected outputs can have slightly different values for cycle period. If this is the case then it is either due to numerical error in the equation solver, or is caused by the model not having reached a limit cycle.

      Note that some outputs of some models may have complex waveforms, for example biphasic peaks. If multiple peaks and troughs are found in each cycle period then period values will reflect the inter-peak interval rather than the true cycle period. At present there is no way around this problem.

    • “ZT Time” represents the ZT time of each peak or trough. It can be seen from the formulae used in the cells that this is calculated simply by subtracting from the peak/trough time the time of the previous ZT0
    • “CT time” represents the Circadian Time, and is only filled in for regimes of constant conditions. Circadian time is calculated as follows:
      • Take the previous ZT0. This is defined as CT0.
      • If this peak/trough is not the first within the present regime of constant conditions, then extrapolate the CT0 time forward using the free running cycle period at the previous peaks in constant conditions. This then gives the last CT0 before the peak in question.

      • Convert the time between this CT0 and the peak in question to circadian hours by multiplying it by 24 dividing by the free running cycle period at this peak.

        Note that if the peaks are far from being evenly spaced, say for example when an erroneous peak appears because the model is far from being entrained, or there is some sort of perturbation, then this extrapolation technique can produce a value outside the range 0 to 24, due to the free running cycle period being distorted, generally shortened. In this case modulo 24 is applied to give a value within the appropriate range. This effectively extrapolates the erroneous cycle period back in time. Discarding an initial period of the time series data (see above) can also cause modulo 24 to be applied to a particular peak or trough CT time, if within the discarded data are peaks or troughs that occurred since the last ZT0. This would make it impossible to extrapolate CT0 forward due to the missing cycle periods. Applying modulo 24 effectively applies the present cycle period over the missing time block. This will of course give a slightly different answer than if all the time series data was retained, unless the model is perfectly entrained and the cycle period does not vary.

      The Cycle Periods, ZT and CT times calculated are expressed as Excel formulae, rather than literal values, thus the user can see exactly how they were calculated, and can alter this if required.

      Note that the columns “ZT Time” and “CT Time” will be missing if the model does not have a light-dark or a temperature cycle. They will be empty if the selected environment consisted only of constant dark, or constant low temperature. This is because in both cases there is no reference for calculating ZT time.

      If the output was integrated then the results will appear below these tables. An example is shown below

      In this example, the user elected to integrate the output cLm, measuring its overlap with the output cTM, against White light. The top half of the table shows time blocks for each day and night for a 12:12 LD cycle (0 to 120 hours). The lower half of the table shows time blocks of one free running cycle period during constant dark (120 to 240 hours, right half), and constant light (240 to 360 hours, left half). If an output is not integrated against either the light-dark or the temperature cycle, then the results appear under the heading "Cycle Periods".

      In order to remove any ambiguity, the exact figures that were used for integration are then displayed to the user. These appear in a column called "Values used for integration", and are plotted on an embedded chart, an example of which is shown below.

      Here Level of LHY mRNA is the output being integrated. Its overlap with Level of TOC1 mRNA is being measured. This is represented by the thick black line. The markers [image] represent the boundaries of the time blocks from the table above. As can be see, for the first 120 hours these coincide with the light-dark cycle, then they represent free running cycle periods. If the output is integrated against the temperature cycle, then the markers for these boundaries are red. Any time point that is used for both cycles will be in pink. If the output is integrated against neither cycle, then the markers will be cyan in colour.

      If the output is not integrated, then a simple time series of the output is plotted alongside the environment cycle on an embedded chart instead.

      Note that the environment is plotted on a secondary y-axis which is hidden from view. The graph displays its relative changing value rather than its absolute value.

    • If the user selected a Perturbations file, then there will be a chart called "Chart - Perturbations Run X", and a worksheet with its source data called "Perturbations Run X". The chart displays the values of any perturbed parameters plotted alongside the environment cycle. For example, in the chart below the user elected to perturb the parameter q1 briefly at dawn on days two to five.

      Note that the environment is plotted on a secondary y-axis which is hidden from view. The graph displays its relative changing value rather than its absolute value.

Next will come a series of charts for each output. There will be a chart called "Chart - Output name", which will plot the time series values on the same axes for each run for comparison.

Note these charts will not display the environmental cycle, as this could vary between runs and so including it could require a very large number of data series to be plotted.

If any values for Circadian Time were calculated for any of the peak times, then these will be plotted against peak number on a chart called "Chart - Output name Peaks", with again a separate data series for each run. This is so it is possible to track any changes in CT time caused by parameter variation between runs, as a change in the time of the peak's position within a free running period may indicate a change in the shape of the waveform. If no CT values were calculated then these charts will not be present.

Finally, for some models there may be one or more extra worksheets of analysis present. This will generally be the case if the model was developed with a specific aim in mind requiring model-specific processing of the data to be carried out. An example of this is our model of the Arabidopsis circadian clock which was developed to measure the effect of photoperiod on induction of flowering, shortly to be available from our website. This model produces an extra table of data showing photoperiod versus percentage flower induction.


Varying Input Files

Comparing Multiple Simulations, varying Model and Environmental Files

See also: Running a Simple Time Series, Comparing Multiple Simulations, varying Model and Environmental Parameters

This experiment allows the user to select multiple combinations of parameters files , environment files, and optionally, perturbations files, to run a time series experiment a defined number of times. Corresponding outputs for each run are compared and plotted on the same axes. Possible uses for this module include comparing a mutation to the wild type, or comparing the same model in different environments, such as a fluence response experiment or a photoperiod experiment. This experiment is similar to the Vary Parameters experiment, except that it is simpler to create separate files if a large number of differences are required between runs.

To run this experiment, first select the Experiments->Time Series->Compare Simulations->Vary Input Files menu item, click the corresponding toolbar button [image], or press Ctrl + F.

Required Input

The user must then navigate through a series of forms that collect the required input. Values already entered can be changed at any time by clicking the "Back" button. The first form is show below:

The data grid has a column for each run. By default there are two runs, but more can be added by clicking "Add a new set of files". A parameters file and an environment file must be selected from the drop-down lists for each run. A perturbations file can also be selected, but this is optional. A name under which the generated Microsoft Excel workbook will be saved must then be entered. Note that the “.xls” extension is not required.

On the next form the user may view the perturbation times as applied to each run. Select a run from the drop down list and the grids will display the perturbation times produced by applying the selected perturbations file, if any, to the selected environment file for that run. See the section on the Perturbations Dialog box to learn more about how perturbation times are defined.

Note some perturbations may be illegal for the selected parameters or environment file for a particular run. The user is warned of any illegal perturbations when a run number is selected and these are automatically not applied.
  • The calculated time values may be out of range for some Environment files..
  • Some parameter perturbations involving adding values to the value from the parameters file may not be possible if the resulting value is invalid for that parameter. However, only individual perturbations are validated. If two valid perturbations acting on the same parameter overlap, then the second perturbation acting on the result of the first may produce a invalid nonsensical value when the simulation is run. For example, a reaction rate constant may be set to a negative value. Very rarely this may cause the simulation to crash.

The changing values of any parameters that are subject to perturbations are plotted in the results workbook for each run so the user can see exactly where they were changed, and to what value.

Clicking "Next" produces the form below.

The user must select which model outputs they wish to appear in the results workbook These correspond to the outputs listed after the model equations on the Model Information Pane. Outputs generally consist of the changing levels of the model states (generally in nM), and various instantaneous rates of change (generally in nM/h) which can be calculated. Rates consist of such things as the rate of expression of a gene, or the rate of degradation of a protein. The required outputs can be selected by checking the appropriate box. The "Select output group" list box simply applies a filter to which outputs are displayed, making the required ones easier to find in, especially for complex models. The workbook produced will contain a worksheet for each selected output for each run.

Note that if the selected parameters file contains an over-expressor gene, then outputs relating to this will be present. Typically these will include the level of mRNA from this gene, the rate of transcription of the gene, and the rates of translation and degradation of the mRNA from the gene. These will be clearly labelled as belonging to the over-expressor gene and will generally appear at the end of the list of all outputs, and will have their own filter. They should not the confused with the corresponding outputs for the native gene, which will still be present even if it is knocked out.

The workbook will also contain summary tables and charts for each output. These show the effect of files chosen on features of the output such as phase and cycle period. Checking the "Plot summary information on same axes" box will cause a single summary chart for each feature to be produced, with all selected outputs plotted on the same axes (see Results section below).

If the "Retain the times series data" box is unchecked, then the results workbook will contain just the summary information and charts, greatly reducing its size. Alternately, leaving this box checked and entering a value in the box will cause an initial period of the time series data to be discarded, the rest being retained.

Clicking "Next" again then displays the integration options box.

Integrating a model state means measuring the area under the curve of its time series plot over a defined range of time values. This then gives a measure of the total amount present during the time range. The purpose of integration is to allow the user to investigate coincidences between states and the environment cycle, for example day time and night time, and between two or more states, for example, the overlap in existence of two proteins. This can answer questions such as "What amount of Protein A is produced during the hours of darkness?", and "What proportion of Protein A is produced when Protein B is present?".

The drop-down list at the top of the form contains a list of all model states that were selected as outputs. To choose to integrate one, select it and then check the box next to its name, as above. Doing this activates the "Measure coincidence with" controls. Their purpose is twofold.

  1. To define the separate time blocks that should be integrated. Under "Environment cycle:" are listed all the environmental components of the current model. In this case the model has only one light colour, and no temperature cycle. Checking the box to integrate against one or more light colours will result in integration values being produced as follows
    • For light-dark regimes with periods each cycle where all selected lights are on, ie "days" and periods where at least one is off, ie "nights", integration values are produced for each day and night.
    • For light-dark regimes were all selected light colours are on throughout the cycle (LL), or where there is no time where all are on (DD, with respect to the combined colours), time blocks are created by dividing the time series up according its free running cycle period under these conditions.

    Integrating against temperature will produce similar results using the high and low temperature values for days and nights respectively. For models with both light-dark and temperature cycles, choosing to integrate against both light and temperature will produce two independent sets of results for each.

    If the user elects not to integrate against any environmental component then the entire time series is divided up into free running cycle periods. It is the period nearest the block in question that is used in each case.

  2. To allow the user to elect to integrate the area under the curve of a state only where it coincides with the presence of another state, ie the area where the two curves overlap. Under "Other selected outputs:" are listed all the other states selected as outputs. Check the relevant boxes to measure the overlap.

To avoid any ambiguity, the results workbook created will display the values which were used for integration. Examples are shown in the Results section below.

The integrated areas measured will appear as part of the summary information. This is particularly useful, if for example, the user wished to perform a photoperiod experiment and look at the effect of varying the light-dark cycle on the coincidence between light and one of the outputs.

Warning: selecting lots of outputs to integrate can add considerably to the time taken to complete the simulation.

Clicking “Finish” will then start the simulation. A progress bar will appear informing the user as each stage of the generation of the workbook is completed. On completion a check box provides the option to automatically open the workbook just created, which will now appear in the results view of the file browser.

Results

On completion of the simulation a check box provides the option to automatically open the workbook just created, which will now appear in the results view of the file browser.

The first worksheet in the workbook is named “Title”. This describes exactly what the results represent, and contains details such as the name of the model, the date and time it was run, all the files selected and their contents. Parameters are listed in groups corresponding to the tabs on the parameters dialog box. Thus a complete definition of the experiment is created, allowing it to be re-produced exactly.

The next worksheet is called "Summary Data". It contains a series of tables, one for each selected output, which displays the how the values of various features of the output vary between runs. An example is shown below:

Here each row represents one run and the combination of files chosen is displayed. If the user elected to retain the time series data, then all values in this table are formulae referencing cells on the appropriate time series sheets. Thus the user can see exactly how each was calculated, and can change this if required. Period is the last measured peak to peak interval for the output. Amplitude is the last measured peak size minus the last measured trough size. Phase values are those for the last peak and trough. CT values are used if present, otherwise ZT values are used.

Note it is sometimes noticed that different selected outputs can have slightly different values for cycle period. If this is the case then it is either due to numerical error in the equation solver, or is caused by the model not having reached a limit cycle.

Note that some outputs of some models may have complex waveforms, for example biphasic peaks. If multiple peaks and troughs are found in each cycle period then as cycle period and amplitude values are calculated using the final peaks and troughs and inter-peak interval, then their values will depend on the phase the model was in when the simulation ended, and will therefore be misleading. At present there is no way around this problem. If unexpected results are found then the user should check the time series plots to ensure that this is not the case.

Note that if the model does not have an external environment, then the phase columns will not be present.

If any integration options were selected, then these values appear next.

The next worksheet is called "Summary Charts". It contains a series of charts for each of the data columns above. If the user elected not to plot summary information on the same axes (see above), then there will be a row of charts for each output. This example is a plot of Peak Phase versus run number.

Next come a set of worksheets for each simulation run.

  1. The first in each set is called "Environment X", where X is the run number. This contains a column of time values (column A), and, if the model has them, corresponding values for light colours and temperature (columns C onwards).

    Note the precise time values at which the changing model outputs were evaluated will vary between experiments, and are simply those determined by the ODE solver to provide the necessary degree of accuracy. However, it should be noted that they are not evenly spaced values, and so model outputs should always be plotted as an XY type scatter plot. The Excel line graph option will display all time points equally spaced along the X axis, distorting the data.

    If the model has a light-dark or a temperature cycle, then next to these values will be a table displaying all the times of ZT0s that occurred during the simulation, as defined by the environment cycle. For those models which have both cycles, these will be labelled "LD" or "TEMP" according to which cycle produced them. For example, the table below was produced by an LD cycle of period 24 hours with lights on at time zero which was repeated 5 times. A switch was them made to DD after 120 hours, hence the missing ZT0s at 120, 144... Lights came on again for the final time at 240 hours.

    The values in this table are used to assign a ZT time to each time point in column A. These appear in column B.

    A table of "On" and "Off" values is then displayed for each environmental component. For any regime of constant conditions which follows a regime with an on-off cycle, predicted on and off times will appear in grey. For example in the table below a 12:12 LD cycle was repeated 5 times. A switch was then made to DD for 5 day, hence the predicted on and off times from 120 to 228 hours in grey. A final switch was then made to LL, hence a "real" on time at 240 hours in black.

  2. Next will be a series of worksheets called "Output name, Run X", one set for each selected output. These contain the time series data, together with the ZT time of each time point, in columns A to C. Next to this in columns E onwards, will be tables for peak and trough values. The left-most columns indicate which light-dark or temperature regime each peak fell in if applicable. The entries in these cells take the form "REG regime number, CP cycle number". Then are columns of peak and trough times and sizes. Several other columns of analysis then follow these:

    • The column “Cycle Period” represents the time difference between each peak/trough and the previous one.

      Note it is sometimes noticed that different selected outputs can have slightly different values for cycle period. If this is the case then it is either due to numerical error in the equation solver, or is caused by the model not having reached a limit cycle.

      Note that some outputs of some models may have complex waveforms, for example biphasic peaks. If multiple peaks and troughs are found in each cycle period then period values will reflect the inter-peak interval rather than the true cycle period. At present there is no way around this problem.

    • “ZT Time” represents the ZT time of each peak or trough. It can be seen from the formulae used in the cells that this is calculated simply by subtracting from the peak/trough time the time of the previous ZT0
    • “CT time” represents the Circadian Time, and is only filled in for regimes of constant conditions. Circadian time is calculated as follows:
      • Take the previous ZT0. This is defined as CT0.
      • If this peak/trough is not the first within the present regime of constant conditions, then extrapolate the CT0 time forward using the free running cycle period at the previous peaks in constant conditions. This then gives the last CT0 before the peak in question.

      • Convert the time between this CT0 and the peak in question to circadian hours by multiplying it by 24 dividing by the free running cycle period at this peak.

        Note that if the peaks are far from being evenly spaced, say for example when an erroneous peak appears because the model is far from being entrained, or there is some sort of perturbation, then this extrapolation technique can produce a value outside the range 0 to 24, due to the free running cycle period being distorted, generally shortened. In this case modulo 24 is applied to give a value within the appropriate range. This effectively extrapolates the erroneous cycle period back in time. Discarding an initial period of the time series data (see above) can also cause modulo 24 to be applied to a particular peak or trough CT time, if within the discarded data are peaks or troughs that occurred since the last ZT0. This would make it impossible to extrapolate CT0 forward due to the missing cycle periods. Applying modulo 24 effectively applies the present cycle period over the missing time block. This will of course give a slightly different answer than if all the time series data was retained, unless the model is perfectly entrained and the cycle period does not vary.

      The Cycle Periods, ZT and CT times calculated are expressed as Excel formulae, rather than literal values, thus the user can see exactly how they were calculated, and can alter this if required.

      Note that the columns “ZT Time” and “CT Time” will be missing if the model does not have a light-dark or a temperature cycle. They will be empty if the selected environment consisted only of constant dark, or constant low temperature. This is because in both cases there is no reference for calculating ZT time.

      If the output was integrated then the results will appear below these tables. An example is shown below

      In this example, the user elected to integrate the output cLm, measuring its overlap with the output cTM, against White light. The top half of the table shows time blocks for each day and night for a 12:12 LD cycle (0 to 120 hours). The lower half of the table shows time blocks of one free running cycle period during constant dark (120 to 240 hours, right half), and constant light (240 to 360 hours, left half). If an output is not integrated against either the light-dark or the temperature cycle, then the results appear under the heading "Cycle Periods".

      In order to remove any ambiguity, the exact figures that were used for integration are then displayed to the user. These appear in a column called "Values used for integration", and are plotted on an embedded chart, an example of which is shown below.

      Here Level of LHY mRNA is the output being integrated. Its overlap with Level of TOC1 mRNA is being measured. This is represented by the thick black line. The markers [image] represent the boundaries of the time blocks from the table above. As can be see, for the first 120 hours these coincide with the light-dark cycle, then they represent free running cycle periods. If the output is integrated against the temperature cycle, then the markers for these boundaries are red. Any time point that is used for both cycles will be in pink. If the output is integrated against neither cycle, then the markers will be cyan in colour.

      If the output is not integrated, then a simple time series of the output is plotted alongside the environment cycle on an embedded chart instead.

      Note that the environment is plotted on a secondary y-axis which is hidden from view. The graph displays its relative changing value rather than its absolute value.

    • If the user selected a Perturbations file, then there will be a chart called "Chart - Perturbations Run X", and a worksheet with its source data called "Perturbations Run X". The chart displays the values of any perturbed parameters plotted alongside the environment cycle. For example, in the chart below the user elected to perturb the parameter q1 briefly at dawn on days two to five.

      Note that the environment is plotted on a secondary y-axis which is hidden from view. The graph displays its relative changing value rather than its absolute value.

Next will come a series of charts for each output. There will be a chart called "Chart - Output name", which will plot the time series values on the same axes for each run for comparison.

Note these charts will not display the environmental cycle, as this could vary between runs and so including it could require a very large number of data series to be plotted.

If any values for Circadian Time were calculated for any of the peak times, then these will be plotted against peak number on a chart called "Chart - Output name Peaks", with again a separate data series for each run. This is so it is possible to track any changes in CT time caused by parameter variation between runs, as a change in the time of the peak's position within a free running period may indicate a change in the shape of the waveform. If no CT values were calculated then these charts will not be present.

Finally, for some models there may be one or more extra worksheets of analysis present. This will generally be the case if the model was developed with a specific aim in mind requiring model-specific processing of the data to be carried out. An example of this is our model of the Arabidopsis circadian clock which was developed to measure the effect of photoperiod on induction of flowering, shortly to be available from our website. This model produces an extra table of data showing photoperiod versus percentage flower induction.


Time-Dependent PRC

Generating a PRC by Varying the Circadian Time of the Perturbation

See also: Perturbation type-dependent PRC, 3D PRC

This is a classical phase response curve, where an organism is entrained to an environmental cycle, and then a short perturbation of consistent duration and size is applied at various CT times over one free running period after transfer to constant conditions. The effect of this on the phase of subsequent oscillations compared to the undisturbed system is plotted against CT time of perturbation. To run this experiment, first select the Experiments->Phase Response Curve->Varying Time of Perturbation menu item, click the corresponding toolbar button [image], or press Ctrl + T.

Required Input

The user must then navigate through a series of forms that collect the required input. Values already entered can be changed at any time by clicking the "Back" button. The first form is show below:

A parameters file and an environment file must be selected from the drop-down lists of available sets. Alternatively, new ones can be created by clicking the "New" button to activate the appropriate dialog box. A name under which the generated Microsoft Excel workbook will be saved must then be entered. Note that the “.xls” extension is not required.

Clicking “Next” brings up the form below. The user can select a perturbations file from the list. When this is done, the perturbations in this file are applied to the selected environment file to create the actual times when they will be applied. See the section on the Perturbations Dialog box to learn more about this. These times are then displayed in the grids for states and parameters.

Note that these perturbations apply to the entraining environment, as defined in the environment file. They are not to be confused with the perturbation that actually creates the PRC, which is applied in the period of constant conditions which follows this entraining environment. These perturbations are applied in the same way each time the simulation is run. They could still possibly affect the PRC however, as they will alter the state the model is in at the end of the entraining environment.

Note some perturbations may be illegal for the selected Parameters file or Environment file. The user is warned of any illegal perturbations when a Perturbations file is selected and these are automatically not applied.
  • The calculated time values may be out of range for some Environment files.
  • Some parameter perturbations involving adding values to the value from the parameters file may not be possible for every file if the resulting value is invalid for that parameter. However, only individual perturbations are validated. If two valid perturbations acting on the same parameter overlap, then the second perturbation acting on the result of the first may produce a invalid nonsensical value when the simulation is run. For example, a reaction rate constant may be set to a negative value. Very rarely this may cause the simulation to crash.

The changing values of any parameters that are subject to perturbations are plotted in the results workbook so the user can see exactly where they were changed, and to what value.

Perturbations files are optional. If one is not required, then simply select "-none-" from the list. This is the default state.

Clicking "Next" bring up the form below.

The user must define the perturbation to be applied to generate the PRC. Here the "Environment" tab is selected. The figure in the "Value" column represents the value of the parameter during the period of constant conditions that will be appended to the environment defined in the environment file, during which the perturbation will be applied. If this parameter is set to constant light (or constant high temperature) at the end of the final regime, then this value will be the "On" value of this parameter in the final regime. Otherwise, it will be the "Off" value. The user can enter a value for any of the environmental parameters that will be produced during the perturbation, by entering a number in the "Perturbation" column. If nothing is entered then the parameter's value does not change during the perturbation. In the above example, the model above has only one environmental parameter, "White" light. This must end in either LD or DD, and so takes its "Off" value, ie darkness, during the period of constant conditions. The user has elected to apply a value of one during the perturbation. The result is that a light pulse of size one will be applied during a period of constant darkness.

The form has two other tabs.

The "States" tab allows the user to apply an instantaneous perturbation to any of the model states. In this case there is no "Value" column. The user can enter an operator followed by a number into the "Perturbation" column. The operators are:
  • "=" to set the state value to be equal to the number when the perturbation is switched on.
  • "*" to multiply the state value by the number when the perturbation is switched on.
  • "+" to add the number to the state value when the perturbation is switched on.

In this example state cXn will be set to two, state cYm will be doubled, and four will be added to the value of state cYc when the perturbation is switched on.

The "Parameters" tab allows the user to apply a perturbation to any of the model parameters. The "Value" column contains the values from the selected parameters file.

Next, the user must define the length of the perturbation, by entering a value in the "Perturbation duration" box. However, if only model states are perturbed then this value does not apply, as state perturbations are applied at one instantaneous moment, so have no duration. If both states and parameters are perturbed then the parameters are perturbed for the duration entered here, and states are perturbed at the moment of the start of the perturbation.

A value must be entered for start time increment between runs. This determines how many simulations will be run to complete the PRC. Perturbation times will cover one cycle period, ie 24 circadian hours, and this number sets the number of circadian hours the start time will be incremented by between runs. In the above example this is set to three, therefore simulations will be run with the perturbation at CT0, CT3, CT6, CT9, CT12, CT15, CT18 and CT21. The lower this number the more accurate the PRC, but the longer the simulation takes to complete.

Clicking "Next" produces the form below.

One of the model outputs must be selected to provide a measure of phase. The value of "Enter number of hours to track phase" sets the length of the period of constant conditions that is appended to the end of the environment file. This determines the number of peak times from the perturbed system that can be compared to corresponding peaks in the control simulation with no perturbation. A phase change caused by a perturbation may take a number of cycles to complete. Setting this value to a relatively long time allows the user to track this. See the results section below.

If the check box “Retain the time series data” is left unchecked then the results workbook will contain the bare minimum number of sheets to produce the final PRC (see below). If this box is checked then all the time series data will be retained, allowing the user to see exactly how the PRC was produced, but greatly enlarging the size of the workbook. If a value greater than zero is entered into the "discarding the first" box, then an initial period of the time series data is not imported into Excel. For example, the user may wish only to retain the time points after the perturbations are applied, as all runs will be identical leading up to this. It is not possible to discard data after this point.

Clicking "Finish" then runs the simulation. A progress bar will appear informing the user as each stage of the generation of the workbook is completed.

The Simulation

The phase response curve is calculated by running a simulation with no perturbation. From the results of this the first CT0 after the start of the appended period of constant conditions is calculated by taking the last ZT0 defined by the environment file as CT0. This time is extrapolated forward by adding the cycle period of the time series until the time exceeds the length of the environment file and enters the appended constant conditions. The cycle period is calculated at each step as being the difference between the next two peaks found after CT0. The cycle period at the final CT0 then defines the time points of the subsequent perturbations. They will be equally spaced over one cycle period (24 circadian hours), starting at CT0. Phase changes in response to the perturbations are calculated for each peak of the control simulation occurring after this time block. This is done by finding the peak closest to each from each experimental run. See below for more explanation.

Note that if the control simulation does not oscillate properly within the period the user entered to track phase, then this calculation may not be possible. In this case the user is informed that the simulation has been abandoned.

Note that if a model has both a light-dark and a temperature cycle, then these are not constrained to be the same length. If they are not then the extra period of constant conditions is appended to the end of the longer of the two, and the other is extrapolated forward until this point. This is done as follows. Any light colour set to LL (see section on environment files) will have its "Ion" value extrapolated forward. Any light colour set to LD or DD will have its "Ioff" value extrapolated. Temperature is treated in the same way, ie if set to constant high temperature then the "Ton" value will be extrapolated, otherwise, it will be the "Toff" value.

Results

On completion of the simulation a check box provides the option to automatically open the workbook just created, which will now appear in the results view of the file browser.

The first worksheet in the workbook is named “Title”. This describes exactly what the results represent, and contains details such as the name of the model, the date and time it was run, all the files selected and their contents. Parameters are listed in groups corresponding to the tabs on the parameters dialog box. The details of the perturbation used to create the PRC are show under this information. Thus a complete definition of the experiment is created, allowing it to be re-produced exactly.

The next worksheet is called “Environment”. This contains a column of time values (column A), and, if the model has them, corresponding values for light colours and temperature (columns C onwards). The time points cover the entraining environment and the additional period for the control run.

Note the precise time values at which the changing model outputs were evaluated will vary between experiments, and are simply those determined by the ODE solver to provide the necessary degree of accuracy. However, it should be noted that they are not evenly spaced values, and so model outputs should always be plotted as an XY type scatter plot. The Excel line graph option will display all time points equally spaced along the X axis, distorting the data.

If the model has a light-dark or a temperature cycle, then next to these values will be a table displaying all the times of ZT0s that occurred during the simulation, as defined by the environment cycle. For those models which have both cycles, these will be labelled "LD" or "TEMP" according to which cycle produced them. For example, the table below was produced by an LD cycle of period 24 hours with lights on at time zero which was repeated 5 times. A switch was them made to DD after 120 hours, hence the missing ZT0s at 120, 144... Lights came on again for the final time at 240 hours.

The values in this table are used to assign a ZT time to each time point in column A. These appear in column B.

A table of "On" and "Off" values is then displayed for each environmental component. For any regime of constant conditions which follows a regime with an on-off cycle, predicted on and off times will appear in grey. For example in the table below a 12:12 LD cycle was repeated 5 times. A switch was then made to DD for 5 day, hence the predicted on and off times from 120 to 228 hours in grey. A final switch was then made to LL, hence a "real" on time at 240 hours in black.

Next will be a worksheet called "PRC Data". This contains a series of tables arranged from left to right, with each representing one peak time value for the control simulation with no perturbation. There is a table for each peak occurring after the time block over which the perturbations were applied. The number depends on the length of time the user elected to track phase over (see above). An example is shown below:

This table represents phase shifts for the first peak found in the control output. This peak was at 286.3 hours, the value in cell C3. Rows four to ten represent the simulations with perturbations. Column A contains the actual times of these perturbations, and column B the CT times of the start of each perturbation. Column C contains the peak time from each run that was closest to the control peak, provided that peak was found after after the time block over which the perturbations were applied. Column D is the change in phase. This is calculated by subtracting the peak time from the control peak, so that phase advances are positive and delays negative, as is the convention in circadian biology. The result is converted to circadian hours by multiplying by 24 divided by the free running cycle period in the control output at this point. Column E "New Phase" is simply the CT time of the perturbation plus the phase change. Modulo 24 is applied to produce a value within the range 0 to 24, although this usually makes no difference to the result as a phase change is rarely greater than a cycle period. These last two columns are Excel formulae rather than literal values. This allows the user to see exactly how the calculations were performed, and to change them if required.

If the user elected to retain the time series data, then below these tables are a series of embedded charts. These are the time series values for each run with a perturbation plotted alongside the control run. The perturbation itself is also plotted so it becomes apparent just how a perturbation at a particular time produces a particular phase shift. Only time values during the appended period of constant conditions are shown as all runs are identical before this. An example is shown below.

Here, the cyan curve represents the time series where the perturbation was applied at CT12. The dotted line is the unperturbed control. The perturbation consists of changes to "White" light and to parameter m1. As can be seen from the graph and the table above, this occurred at 255 hours. This graph demonstrated how such a perturbation produces a phase delay.

Parameter q1 is not part of the perturbation, but is plotted here because it was perturbed earlier on in the simulation because the user selected a perturbations file. This was done identically for every run. This is explained below.

Note that the perturbation is plotted on a secondary y-axis which is hidden from view. The graph displays its relative changing value rather than its absolute value.

The next sheet will be a chart called "Phase Shifts". This plots phase change values from the above table against peak number. This allows the user to track how phase shifts may develop over a number of cycles.

The next charts are the actual Phase Response Curve and the Phase Transition Curve. The PRC is produced from the table above by plotting phase change against CT time of perturbation for the last control peak. The PTC is produced by plotting new phase against CT time of perturbation for the last control peak. The solid line represents new phase equals old phase.

If the user elected to use a perturbations file, then any perturbations applied from this will have been during the entraining environment so will have been applied equally to all runs. They could still possibly affect the PRC however, as they will alter the state the model is in at the end of the entraining environment. If any model parameters were perturbed by this file, then the next two sheets will be a chart called "Chart - Parameter Perturbations", and a worksheet of the source data called "Parameter Perturbations". The chart displays the values of any perturbed parameters plotted alongside the environment cycle for the entire simulation. For example, in the chart below the user elected to perturb the parameter q1 briefly at dawn on days two to five.

Note that the environment is plotted on a secondary y-axis which is hidden from view. The graph displays its relative changing value rather than its absolute value.

After these charts, if the user elected to retain them, come the actual time series data. There is one worksheet for each run. The first is the control run with no perturbation. It will be called "Outputname, no perturbation". The time series data, together with the ZT time of each time point, is found in columns columns A to C. Next to this in columns E onwards, will be tables for peak values. The left-most columns indicate which light-dark or temperature regime each peak fell in if applicable. The entries in these cells take the form "REG regime number, CP cycle number". Then are columns of peak times and sizes. Several other columns of analysis then follow these:

  • The column “Cycle Period” represents the time difference between each peak/trough and the previous one.

    Note that some outputs of some models may have complex waveforms, for example biphasic peaks. If multiple peaks and troughs are found in each cycle period then period values will reflect the inter-peak interval rather than the true cycle period. This will distort the measured phase change values, and at present there is no way around this problem.

  • “ZT Time” represents the ZT time of each peak. It can be seen from the formulae used in the cells that this is calculated simply by subtracting from the peak time the time of the previous ZT0
  • “CT time” represents the Circadian Time, and is only filled in for regimes of constant conditions. Circadian time is calculated as follows:
    • Take the previous ZT0. This is defined as CT0.
    • If this peak is not the first within the present regime of constant conditions, then extrapolate the CT0 time forward using the free running cycle period at the previous peaks in constant conditions. This then gives the last CT0 before the peak in question.

    • Convert the time between this CT0 and the peak in question to circadian hours by multiplying it by 24 dividing by the free running cycle period at this peak.

      Note that if the peaks are far from being evenly spaced, say for example when an erroneous peak appears because the model is far from being entrained, or there is some sort of perturbation, then this extrapolation technique can produce a value outside the range 0 to 24, due to the free running cycle period being distorted, generally shortened. In this case modulo 24 is applied to give a value within the appropriate range. This effectively extrapolates the erroneous cycle period back in time. Discarding an initial period of the time series data (see above) can also cause modulo 24 to be applied to a particular peak or trough CT time, if within the discarded data are peaks or troughs that occurred since the last ZT0. This would make it impossible to extrapolate CT0 forward due to the missing cycle periods. Applying modulo 24 effectively applies the present cycle period over the missing time block. This will of course give a slightly different answer than if all the time series data was retained, unless the model is perfectly entrained and the cycle period does not vary.

    The Cycle Periods, ZT and CT times calculated are expressed as Excel formulae, rather than literal values, thus the user can see exactly how they were calculated, and can alter this if required.

    Note
    • Columns “ZT Time” and “CT Time” will be empty if the entraining environment consisted only of constant dark, or constant low temperature. This is because in both cases there is no reference for calculating ZT time. However, for the purposes of the PRC, time zero will have been assumed to represent ZT0.
    • These columns will be missing if the model does not have a light-dark or a temperature cycle. In this case CT0 will be assumed to be at the end of the entraining period.

    Below this table will be an embedded chart of the time series values plotted alongside the environment. This will be for the entraining period, minus any initial period the user opted to discard, plus the additional constant conditions that were appended to create the PRC.

    Following this worksheet will be series of sheets for each perturbation, called "Outputname, perturbation at CTtime". These contain time series data in columns A to C as above, and a table of peak times. However, the time values only cover time of the first perturbation at CT0 onwards, as before this they would be identical to the control. Values for any model parameters that are perturbed appear in columns D onwards.

    Note that for these sheets, CT time of the peaks is not calculated, even though it may have been for the control run. This is because it would not be meaningful to calculate circadian time in this way when the system has been distorted by a perturbation. The circadian time of these peaks can be found from the phase shift values.


Type-Dependent PRC

Generating a PRC by Varying Type of Perturbation

See also: Perturbation time-dependent PRC, 3D PRC

This is a phase response curve where an organism is entrained to an environmental cycle, and then a number of different short perturbations are applied at the same CT time after transfer to constant conditions. The effect of perturbation type on the phase of subsequent oscillations compared to the undisturbed system is plotted against type of perturbation. To run this experiment, first select the Experiments->Phase Response Curve->Varying Size of Perturbation menu item, click the corresponding toolbar button [image], or press Ctrl + I.

Required Input

The user must then navigate through a series of forms that collect the required input. Values already entered can be changed at any time by clicking the "Back" button. The first form is show below:

A parameters file and an environment file must be selected from the drop-down lists of available sets. Alternatively, new ones can be created by clicking the "New" button to activate the appropriate dialog box. A name under which the generated Microsoft Excel workbook will be saved must then be entered. Note that the “.xls” extension is not required.

Clicking “Next” brings up the form below. The user can select a perturbations file from the list. When this is done, the perturbations in this file are applied to the selected environment file to create the actual times when they will be applied. See the section on the Perturbations Dialog box to learn more about this. These times are then displayed in the grids for states and parameters.

Note that these perturbations apply to the entraining environment, as defined in the environment file. They are not to be confused with the perturbation that actually creates the PRC, which is applied in the period of constant conditions which follows this entraining environment. These perturbations are applied in the same way each time the simulation is run. They could still possibly affect the PRC however, as they will alter the state the model is in at the end of the entraining environment.

Note some perturbations may be illegal for the selected Parameters file or Environment file. The user is warned of any illegal perturbations when a Perturbations file is selected and these are automatically not applied.
  • The calculated time values may be out of range for some Environment files.
  • Some parameter perturbations involving adding values to the value from the parameters file may not be possible for every file if the resulting value is invalid for that parameter. However, only individual perturbations are validated. If two valid perturbations acting on the same parameter overlap, then the second perturbation acting on the result of the first may produce a invalid nonsensical value when the simulation is run. For example, a reaction rate constant may be set to a negative value. Very rarely this may cause the simulation to crash.

The changing values of any parameters that are subject to perturbations are plotted in the results workbook so the user can see exactly where they were changed, and to what value.

Perturbations files are optional. If one is not required, then simply select "-none-" from the list. This is the default state.

Clicking "Next" bring up the form below.

The user must define each perturbation to be applied to generate the PRC. Here the "Environment" tab is selected. The figure in the "Value" column represents the value of the parameter during the period of constant conditions that will be appended to the environment defined in the environment file, during which the perturbations will be applied. If this parameter is set to constant light (or constant high temperature) at the end of the final regime, then this value will be the "On" value of this parameter in the final regime. Otherwise, it will be the "Off" value. The user can enter a value for any of the environmental parameters that will be produced during the perturbation, by entering a number in the "Perturb 1" column. If nothing is entered then the parameter's value does not change during the perturbation. In the above example, the model above has only one environmental parameter, "White" light. This must end in either LD or DD, and so takes its "Off" value, ie darkness, during the period of constant conditions. The user has elected to apply a value of one during the first perturbation. The result is that a light pulse of size one will be applied during a period of constant darkness.

The form has two other tabs. Clicking the "Add a new perturbation" button will add an extra column to the data grid on all three tabs. This will have the heading "Perturb 2". This allows the user to define a second perturbation, which may be completely different from the first. Additional perturbations can be created as required.

The "States" tab allows the user to apply an instantaneous perturbation to any of the model states. In this case there is no "Value" column. The user can enter an operator followed by a number into the "Perturb" column. The operators are:
  • "=" to set the state value to be equal to the number when the perturbation is switched on.
  • "*" to multiply the state value by the number when the perturbation is switched on.
  • "+" to add the number to the state value when the perturbation is switched on.

In this example during the first perturbation, two will be added to the level of state cLc, and during the second perturbation, state cTm will be set to zero and state cLn will be doubled when the perturbation is switched on.

The "Parameters" tab allows the user to apply a perturbation to any of the model parameters. The "Value" column contains the values from the selected parameters file.

Each perturbation consists of all values entered into its column on all three tabs, ie the numbers in the column headings indicate which environment, state and parameter perturbations will be combined together on a particular run.

Next, the user must define the length of the perturbation, by entering a value in the "Perturbation duration" box. However, if only model states are perturbed then this value does not apply, as state perturbations are applied at one instantaneous moment, so have no duration. If both states and parameters are perturbed then the parameters are perturbed for the duration entered here, and states are perturbed at the moment of the start of the perturbation.

Finally, the user must enter the circadian phase at which the perturbations will be applied. This value is in circadian hours and must between zero and 24.

Clicking "Next" produces the form below.

One of the model outputs must be selected to provide a measure of phase. The value of "Enter number of hours to track phase" sets the length of the period of constant conditions that is appended to the end of the environment file. This determines the number of peak times from the perturbed system that can be compared to corresponding peaks in the control simulation with no perturbation. A phase change caused by a perturbation may take a number of cycles to complete. Setting this value to a relatively long time allows the user to track this. See the results section below.

If the check box “Retain the time series data” is left unchecked then the results workbook will contain the bare minimum number of sheets to produce the final PRC (see below). If this box is checked then all the time series data will be retained, allowing the user to see exactly how the PRC was produced, but greatly enlarging the size of the workbook. If a value greater than zero is entered into the "discarding the first" box, then an initial period of the time series data is not imported into Excel. For example, the user may wish only to retain the time points after the perturbations are applied, as all runs will be identical leading up to this. It is not possible to discard data after this point.

Clicking "Finish" then runs the simulation. A progress bar will appear informing the user as each stage of the generation of the workbook is completed.

The Simulation

The phase response curve is calculated by running a simulation with no perturbation. From the results of this the first CT0 after the start of the appended period of constant conditions is calculated by taking the last ZT0 defined by the environment file as CT0. This time is extrapolated forward by adding the cycle period of the time series until the time exceeds the length of the environment file and enters the appended constant conditions. The cycle period is calculated at each step as being the difference between the next two peaks found after CT0. The cycle period at the final CT0 then defines the time point at which the perturbations will be applied. Phase changes in response to the perturbations are calculated for each peak of the control simulation occurring after this time block. This is done by finding the peak closest to each from each experimental run. See below for more explanation.

Note that if the control simulation does not oscillate properly within the period the user entered to track phase, then this calculation may not be possible. In this case the user is informed that the simulation has been abandoned.

Note that if a model has both a light-dark and a temperature cycle, then these are not constrained to be the same length. If they are not then the extra period of constant conditions is appended to the end of the longer of the two, and the other is extrapolated forward until this point. This is done as follows. Any light colour set to LL (see section on environment files) will have its "Ion" value extrapolated forward. Any light colour set to LD or DD will have its "Ioff" value extrapolated. Temperature is treated in the same way, ie if set to constant high temperature then the "Ton" value will be extrapolated, otherwise, it will be the "Toff" value.

Results

On completion of the simulation a check box provides the option to automatically open the workbook just created, which will now appear in the results view of the file browser.

The first worksheet in the workbook is named “Title”. This describes exactly what the results represent, and contains details such as the name of the model, the date and time it was run, all the files selected and their contents. Parameters are listed in groups corresponding to the tabs on the parameters dialog box. The details of the perturbation used to create the PRC are show under this information. Thus a complete definition of the experiment is created, allowing it to be re-produced exactly.

The next worksheet is called “Environment”. This contains a column of time values (column A), and, if the model has them, corresponding values for light colours and temperature (columns C onwards). The time points cover the entraining environment and the additional period for the control run.

Note the precise time values at which the changing model outputs were evaluated will vary between experiments, and are simply those determined by the ODE solver to provide the necessary degree of accuracy. However, it should be noted that they are not evenly spaced values, and so model outputs should always be plotted as an XY type scatter plot. The Excel line graph option will display all time points equally spaced along the X axis, distorting the data.

If the model has a light-dark or a temperature cycle, then next to these values will be a table displaying all the times of ZT0s that occurred during the simulation, as defined by the environment cycle. For those models which have both cycles, these will be labelled "LD" or "TEMP" according to which cycle produced them. For example, the table below was produced by an LD cycle of period 24 hours with lights on at time zero which was repeated 5 times. A switch was them made to DD after 120 hours, hence the missing ZT0s at 120, 144... Lights came on again for the final time at 240 hours.

The values in this table are used to assign a ZT time to each time point in column A. These appear in column B.

A table of "On" and "Off" values is then displayed for each environmental component. For any regime of constant conditions which follows a regime with an on-off cycle, predicted on and off times will appear in grey. For example in the table below a 12:12 LD cycle was repeated 5 times. A switch was then made to DD for 5 day, hence the predicted on and off times from 120 to 228 hours in grey. A final switch was then made to LL, hence a "real" on time at 240 hours in black.

Next will be a worksheet called "PRC Data". This contains a series of tables arranged from left to right, with each representing one peak time value for the control simulation with no perturbation. There is a table for each peak occurring after the time block over which the perturbations were applied. The number depends on the length of time the user elected to track phase over (see above). An example is shown below:

This table represents phase shifts for the first peak found in the control output. This peak was at 98.5 hours, the value in cell C3. Rows four to eight represent the simulations with perturbations. Column A contains the perturbation number, and column B the details of each perturbation, as defined by the user above. Column C contains the peak time from each run that was closest to the control peak, provided that peak was found after after the time at which the perturbations were applied. Column D is the change in phase. This is calculated by subtracting the peak time from the control peak, so that phase advances are positive and delays negative, as is the convention in circadian biology. The result is converted to circadian hours by multiplying by 24 divided by the free running cycle period in the control output at this point. Column E "New Phase" is simply the CT time of the perturbation plus the phase change. Modulo 24 is applied to produce a value within the range 0 to 24, although this usually makes no difference to the result as a phase change is rarely greater than a cycle period. These last two columns are Excel formulae rather than literal values. This allows the user to see exactly how the calculations were performed, and to change them if required.

If the user elected to retain the time series data, then below these tables are a series of embedded charts. These are the time series values for each run with a perturbation plotted alongside the control run. The perturbation itself is also plotted so it becomes apparent just how each perturbation produces a particular phase shift. Only time values during the appended period of constant conditions are shown as all runs are identical before this. An example is shown below.

Here, the yellow curve represents the time series when perturbation 4 was applied. The dotted red line is the unperturbed control. The perturbation consists of changes to state cTm and to parameter n3. This graph demonstrated how such a perturbation produces a phase delay.

Parameter q1 is not part of the perturbation, but is plotted here because it was perturbed earlier on in the simulation because the user selected a perturbations file. This was done identically for every run. This is explained below.

Note that the perturbation is plotted on a secondary y-axis which is hidden from view. The graph displays its relative changing value rather than its absolute value.

The next sheet will be a chart called "Phase Shifts". This plots phase change values from the above table against peak number. This allows the user to track how phase shifts may develop over a number of cycles.

The next charts are the actual Phase Response Curve and the Phase Transition Curve. The PRC is produced from the table above by plotting phase change against perturbation number for the last control peak. The PTC is produced by plotting new phase against perturbation number for the last control peak. The solid line represents new phase equals old phase, ie a perturbation with no effect on phase.

If the user elected to use a perturbations file, then any perturbations applied from this will have been during the entraining environment so will have been applied equally to all runs. They could still possibly affect the PRC however, as they will alter the state the model is in at the end of the entraining environment. If any model parameters were perturbed by this file, then the next two sheets will be a chart called "Chart - Parameter Perturbations", and a worksheet of the source data called "Parameter Perturbations". The chart displays the values of any perturbed parameters plotted alongside the environment cycle for the entire simulation. For example, in the chart below the user elected to perturb the parameter q1 briefly at dawn on days two to five.

After these charts, if the user elected to retain them, come the actual time series data. There is one worksheet for each run. The first is the control run with no perturbation. It will be called "Outputname, no perturbation". The time series data, together with the ZT time of each time point, is found in columns columns A to C. Next to this in columns E onwards, will be tables for peak values. The left-most columns indicate which light-dark or temperature regime each peak fell in if applicable. The entries in these cells take the form "REG regime number, CP cycle number". Then are columns of peak times and sizes. Several other columns of analysis then follow these:

  • The column “Cycle Period” represents the time difference between each peak/trough and the previous one.

    Note that some outputs of some models may have complex waveforms, for example biphasic peaks. If multiple peaks and troughs are found in each cycle period then period values will reflect the inter-peak interval rather than the true cycle period. This will distort the measured phase change values, and at present there is no way around this problem.

  • “ZT Time” represents the ZT time of each peak. It can be seen from the formulae used in the cells that this is calculated simply by subtracting from the peak time the time of the previous ZT0
  • “CT time” represents the Circadian Time, and is only filled in for regimes of constant conditions. Circadian time is calculated as follows:
    • Take the previous ZT0. This is defined as CT0.
    • If this peak is not the first within the present regime of constant conditions, then extrapolate the CT0 time forward using the free running cycle period at the previous peaks in constant conditions. This then gives the last CT0 before the peak in question.

    • Convert the time between this CT0 and the peak in question to circadian hours by multiplying it by 24 dividing by the free running cycle period at this peak.

      Note that if the peaks are far from being evenly spaced, say for example when an erroneous peak appears because the model is far from being entrained, or there is some sort of perturbation, then this extrapolation technique can produce a value outside the range 0 to 24, due to the free running cycle period being distorted, generally shortened. In this case modulo 24 is applied to give a value within the appropriate range. This effectively extrapolates the erroneous cycle period back in time. Discarding an initial period of the time series data (see above) can also cause modulo 24 to be applied to a particular peak or trough CT time, if within the discarded data are peaks or troughs that occurred since the last ZT0. This would make it impossible to extrapolate CT0 forward due to the missing cycle periods. Applying modulo 24 effectively applies the present cycle period over the missing time block. This will of course give a slightly different answer than if all the time series data was retained, unless the model is perfectly entrained and the cycle period does not vary.

    The Cycle Periods, ZT and CT times calculated are expressed as Excel formulae, rather than literal values, thus the user can see exactly how they were calculated, and can alter this if required.

    Note
    • Columns “ZT Time” and “CT Time” will be empty if the entraining environment consisted only of constant dark, or constant low temperature. This is because in both cases there is no reference for calculating ZT time. However, for the purposes of the PRC, time zero will have been assumed to represent ZT0.
    • These columns will be missing if the model does not have a light-dark or a temperature cycle. In this case CT0 will be assumed to be at the end of the entraining period.

    Below this table will be an embedded chart of the time series values plotted alongside the environment. This will be for the entraining period, minus any initial period the user opted to discard, plus the additional constant conditions that were appended to create the PRC.

    Following this worksheet will be series of sheets for each perturbation, called "Outputname, perturbation number". These contain time series data in columns A to C as above, and a table of peak times. However, the time values only cover time of the perturbation onwards, as before this they would be identical to the control. Values for any model parameters that are perturbed appear in columns D onwards.

    Note that for these sheets, CT time of the peaks is not calculated, even though it may have been for the control run. This is because it would not be meaningful to calculate circadian time in this way when the system has been distorted by a perturbation. The circadian time of these peaks can be found from the phase shift values.


3D PRC

Generating a 3D PRC by Varying the Circadian Time and Type of the Perturbation

See also: Perturbation time-dependent PRC, Perturbation type-dependent PRC

This is a phase response curve where an organism is entrained to an environmental cycle, and then a short perturbation of consistent duration and size is applied at various CT times over one free running period after transfer to constant conditions. The effect of this on the phase of subsequent oscillations compared to the undisturbed system is plotted against CT time of perturbation. This is repeated with different perturbations to produce a 3D plot of phase shift versus CT time versus perturbation type. To run this experiment, first select the Experiments->Phase Response Curve->3D... menu item, click the corresponding toolbar button [image], or press Ctrl + D.

Required Input

The user must then navigate through a series of forms that collect the required input. Values already entered can be changed at any time by clicking the "Back" button. The first form is show below:

A parameters file and an environment file must be selected from the drop-down lists of available sets. Alternatively, new ones can be created by clicking the "New" button to activate the appropriate dialog box. A name under which the generated Microsoft Excel workbook will be saved must then be entered. Note that the “.xls” extension is not required.

Clicking “Next” brings up the form below. The user can select a perturbations file from the list. When this is done, the perturbations in this file are applied to the selected environment file to create the actual times when they will be applied. See the section on the Perturbations Dialog box to learn more about this. These times are then displayed in the grids for states and parameters.

Note that these perturbations apply to the entraining environment, as defined in the environment file. They are not to be confused with the perturbation that actually creates the PRC, which is applied in the period of constant conditions which follows this entraining environment. These perturbations are applied in the same way each time the simulation is run. They could still possibly affect the PRC however, as they will alter the state the model is in at the end of the entraining environment.

Note some perturbations may be illegal for the selected Parameters file or Environment file. The user is warned of any illegal perturbations when a Perturbations file is selected and these are automatically not applied.
  • The calculated time values may be out of range for some Environment files.
  • Some parameter perturbations involving adding values to the value from the parameters file may not be possible for every file if the resulting value is invalid for that parameter. However, only individual perturbations are validated. If two valid perturbations acting on the same parameter overlap, then the second perturbation acting on the result of the first may produce a invalid nonsensical value when the simulation is run. For example, a reaction rate constant may be set to a negative value. Very rarely this may cause the simulation to crash.

The changing values of any parameters that are subject to perturbations are plotted in the results workbook so the user can see exactly where they were changed, and to what value.

Perturbations files are optional. If one is not required, then simply select "-none-" from the list. This is the default state.

Clicking "Next" bring up the form below.

The user must define the perturbations to be applied to generate the PRC. Here the "Environment" tab is selected. The figure in the "Value" column represents the value of the parameter during the period of constant conditions that will be appended to the environment defined in the environment file, during which the perturbations will be applied. If this parameter is set to constant light (or constant high temperature) at the end of the final regime, then this value will be the "On" value of this parameter in the final regime. Otherwise, it will be the "Off" value. The user can enter a value for any of the environmental parameters that will be produced during the perturbations, by entering a number in the "Perturb 1" column. If nothing is entered then the parameter's value does not change during the perturbation. In the above example, the model above has only one environmental parameter, "White" light. This must end in either LD or DD, and so takes its "Off" value, ie darkness, during the period of constant conditions. The user has elected to apply a value of 0.25 during the first perturbation. The result is that a light pulse of this size will be applied during a period of constant darkness.

The form has two other tabs.

The "States" tab allows the user to apply an instantaneous perturbation to any of the model states. In this case there is no "Value" column. The user can enter an operator followed by a number into the "Perturbation" column. The operators are:
  • "=" to set the state value to be equal to the number when the perturbation is switched on.
  • "*" to multiply the state value by the number when the perturbation is switched on.
  • "+" to add the number to the state value when the perturbation is switched on.

In this example during the first perturbation, two will be added to the level of state cLc, and during the second perturbation, state cTm will be set to zero and state cLn will be doubled when the perturbation is switched on.

The "Parameters" tab allows the user to apply a perturbation to any of the model parameters. The "Value" column contains the values from the selected parameters file.

Each perturbation consists of all values entered into its column on all three tabs, ie the numbers in the column headings indicate which environment, state and parameter perturbations will be combined together on a particular run.

Next, the user must define the length of the perturbation, by entering a value in the "Perturbation duration" box. However, if only model states are perturbed then this value does not apply, as state perturbations are applied at one instantaneous moment, so have no duration. If both states and parameters are perturbed then the parameters are perturbed for the duration entered here, and states are perturbed at the moment of the start of the perturbation.

A value must be entered for start time increment between runs. This determines how many simulations will be run to complete the PRC. Perturbation times will cover one cycle period, ie 24 circadian hours, and this number sets the number of circadian hours the start time will be incremented by between runs. In the above example this is set to two, therefore simulations will be run with the perturbation at CT0, CT2, CT4, CT6, CT8, CT10, CT12, CT14, CT16, CT18, CT20 and CT22. The lower this number the more accurate the PRC, but the longer the simulation takes to complete.

Clicking "Next" produces the form below.

One of the model outputs must be selected to provide a measure of phase. The value of "Enter number of hours to track phase" sets the length of the period of constant conditions that is appended to the end of the environment file. This determines the number of peak times from the perturbed system that can be compared to corresponding peaks in the control simulation with no perturbation. A phase change caused by a perturbation may take a number of cycles to complete. Setting this value to a relatively long time allows the user to track this. See the results section below.

If the check box “Retain the time series data” is left unchecked then the results workbook will contain the bare minimum number of sheets to produce the final PRC (see below). If this box is checked then all the time series data will be retained, allowing the user to see exactly how the PRC was produced, but greatly enlarging the size of the workbook. If a value greater than zero is entered into the "discarding the first" box, then an initial period of the time series data is not imported into Excel. For example, the user may wish only to retain the time points after the perturbations are applied, as all runs will be identical leading up to this. It is not possible to discard data after this point.

Clicking "Finish" then runs the simulation. A progress bar will appear informing the user as each stage of the generation of the workbook is completed.

The Simulation

The phase response curve is calculated by running a simulation with no perturbation. From the results of this the first CT0 after the start of the appended period of constant conditions is calculated by taking the last ZT0 defined by the environment file as CT0. This time is extrapolated forward by adding the cycle period of the time series until the time exceeds the length of the environment file and enters the appended constant conditions. The cycle period is calculated at each step as being the difference between the next two peaks found after CT0. The cycle period at the final CT0 then defines the time points of the subsequent perturbations. They will be equally spaced over one cycle period (24 circadian hours), starting at CT0. Each of the defined perturbations will be applied at each CT time. Phase changes in response to the perturbations are calculated for each peak of the control simulation occurring after this time block. This is done by finding the peak closest to each from each experimental run. See below for more explanation.

Note that if the control simulation does not oscillate properly within the period the user entered to track phase, then this calculation may not be possible. In this case the user is informed that the simulation has been abandoned.

Note that if a model has both a light-dark and a temperature cycle, then these are not constrained to be the same length. If they are not then the extra period of constant conditions is appended to the end of the longer of the two, and the other is extrapolated forward until this point. This is done as follows. Any light colour set to LL (see section on environment files) will have its "Ion" value extrapolated forward. Any light colour set to LD or DD will have its "Ioff" value extrapolated. Temperature is treated in the same way, ie if set to constant high temperature then the "Ton" value will be extrapolated, otherwise, it will be the "Toff" value.

Results

On completion of the simulation a check box provides the option to automatically open the workbook just created, which will now appear in the results view of the file browser.

The first worksheet in the workbook is named “Title”. This describes exactly what the results represent, and contains details such as the name of the model, the date and time it was run, all the files selected and their contents. Parameters are listed in groups corresponding to the tabs on the parameters dialog box. The details of the perturbation used to create the PRC are show under this information. Thus a complete definition of the experiment is created, allowing it to be re-produced exactly.

The next worksheet is called “Environment”. This contains a column of time values (column A), and, if the model has them, corresponding values for light colours and temperature (columns C onwards). The time points cover the entraining environment and the additional period for the control run.

Note the precise time values at which the changing model outputs were evaluated will vary between experiments, and are simply those determined by the ODE solver to provide the necessary degree of accuracy. However, it should be noted that they are not evenly spaced values, and so model outputs should always be plotted as an XY type scatter plot. The Excel line graph option will display all time points equally spaced along the X axis, distorting the data.

If the model has a light-dark or a temperature cycle, then next to these values will be a table displaying all the times of ZT0s that occurred during the simulation, as defined by the environment cycle. For those models which have both cycles, these will be labelled "LD" or "TEMP" according to which cycle produced them. For example, the table below was produced by an LD cycle of period 24 hours with lights on at time zero which was repeated 5 times. A switch was them made to DD after 120 hours, hence the missing ZT0s at 120, 144... Lights came on again for the final time at 240 hours.

The values in this table are used to assign a ZT time to each time point in column A. These appear in column B.

A table of "On" and "Off" values is then displayed for each environmental component. For any regime of constant conditions which follows a regime with an on-off cycle, predicted on and off times will appear in grey. For example in the table below a 12:12 LD cycle was repeated 5 times. A switch was then made to DD for 5 day, hence the predicted on and off times from 120 to 228 hours in grey. A final switch was then made to LL, hence a "real" on time at 240 hours in black.

Next will be a worksheet called "PRC Data". This contains a series of tables arranged from left to right, with each representing one perturbation type. Within each table, groups of columns represent each peak time value for the control simulation with no perturbation. There is a column group for each peak occurring after the time block over which the perturbations were applied. The number depends on the length of time the user elected to track phase over (see above). An example of part of one table is shown below:

This table represents perturbation number one, the details of which appear in cell D1. This perturbation consisted of setting "White" light to 0.25 and parameter n3 to 0.1. This part of the table shows phase shifts for the first peak found in the control output. This peak was at 124.2 hours, the value in cell C3. Rows four to seven represent the simulations with this perturbation. Column A contains the actual times of these perturbations, and column B the CT times of the start of each perturbation. Column C contains the peak time from each run that was closest to the control peak, provided that peak was found after after the time block over which the perturbations were applied. Column D is the change in phase. This is calculated by subtracting the peak time from the control peak, so that phase advances are positive and delays negative, as is the convention in circadian biology. The result is converted to circadian hours by multiplying by 24 divided by the free running cycle period in the control output at this point. Column E "New Phase" is simply the CT time of the perturbation plus the phase change. Modulo 24 is applied to produce a value within the range 0 to 24, although this usually makes no difference to the result as a phase change is rarely greater than a cycle period. These last two columns are Excel formulae rather than literal values. This allows the user to see exactly how the calculations were performed, and to change them if required.

There will be a series of these tables, one for each perturbation defined by the user.

If the user elected to retain the time series data, then below each table is a column of embedded charts. These are the time series values for each run of this perturbation. They show the data plotted alongside the control run. The perturbation itself is also plotted so it becomes apparent just how a perturbation at a particular time produces a particular phase shift. Only time values during the appended period of constant conditions are shown as all runs are identical before this. An example is shown below.

This chart represents perturbation number four applied at CT18. The cyan curve represents the time series with the perturbation and the dotted line is the unperturbed control. The perturbation consists of changes to "White" light and to parameter n3. As can be seen from the graph and the table above, this occurred at 116.8 hours. This graph demonstrated how such a perturbation produces a phase delay.

Parameter n2 is not part of the perturbation, but is plotted here because it was perturbed earlier on in the simulation because the user selected a perturbations file. This was done identically for every run. This is explained below.

Note that the perturbation is plotted on a secondary y-axis which is hidden from view. The graph displays its relative changing value rather than its absolute value.

The next sheet is called "Phase Shifts". This contains a series of plots of phase change values from the above table against peak number. There is one plot for each perturbation type and each has one data series for each CT time. This allows the user to track how phase shifts may develop over a number of cycles.

The next sheet is called "2D Plots". This contains the following plots:

  • Two phase response curves
    • One with phase change for the last control peak plotted against CT time of perturbation, with one data series for each perturbation.
    • Another with phase change for the last control peak plotted against perturbation number, with one data series for each CT time.
  • Two phase transition curves
    • One with new phase for the last control peak plotted against CT time of perturbation, with one data series for each perturbation. The solid line represents new phase equals old phase.
    • Another with new phase for the last control peak plotted against perturbation number, with one data series for each CT time.

The next charts are the 3D Phase Response Curve and the 3D Phase Transition Curve. The PRC is produced from the table above by plotting phase change for the last control peak against CT time of perturbation, with a data series for each perturbation type. The PTC is produced by plotting new phase for the last control peak against CT time of perturbation, with a data series for each perturbation.

If the user elected to use a perturbations file, then any perturbations applied from this will have been during the entraining environment so will have been applied equally to all runs. They could still possibly affect the PRC however, as they will alter the state the model is in at the end of the entraining environment. If any model parameters were perturbed by this file, then the next two sheets will be a chart called "Chart - Parameter Perturbations", and a worksheet of the source data called "Parameter Perturbations". The chart displays the values of any perturbed parameters plotted alongside the environment cycle for the entire simulation. For example, in the chart below the user elected to perturb the parameter q1 briefly at dawn on days two to five.

Note that the environment is plotted on a secondary y-axis which is hidden from view. The graph displays its relative changing value rather than its absolute value.

After these charts, if the user elected to retain them, come the actual time series data. There is one worksheet for each run. The first is the control run with no perturbation. It will be called "Outputname, no perturbation". The time series data, together with the ZT time of each time point, is found in columns columns A to C. Next to this in columns E onwards, will be tables for peak values. The left-most columns indicate which light-dark or temperature regime each peak fell in if applicable. The entries in these cells take the form "REG regime number, CP cycle number". Then are columns of peak times and sizes. Several other columns of analysis then follow these:

  • The column “Cycle Period” represents the time difference between each peak/trough and the previous one.

    Note that some outputs of some models may have complex waveforms, for example biphasic peaks. If multiple peaks and troughs are found in each cycle period then period values will reflect the inter-peak interval rather than the true cycle period. This will distort the measured phase change values, and at present there is no way around this problem.

  • “ZT Time” represents the ZT time of each peak. It can be seen from the formulae used in the cells that this is calculated simply by subtracting from the peak time the time of the previous ZT0
  • “CT time” represents the Circadian Time, and is only filled in for regimes of constant conditions. Circadian time is calculated as follows:
    • Take the previous ZT0. This is defined as CT0.
    • If this peak is not the first within the present regime of constant conditions, then extrapolate the CT0 time forward using the free running cycle period at the previous peaks in constant conditions. This then gives the last CT0 before the peak in question.

    • Convert the time between this CT0 and the peak in question to circadian hours by multiplying it by 24 dividing by the free running cycle period at this peak.

      Note that if the peaks are far from being evenly spaced, say for example when an erroneous peak appears because the model is far from being entrained, or there is some sort of perturbation, then this extrapolation technique can produce a value outside the range 0 to 24, due to the free running cycle period being distorted, generally shortened. In this case modulo 24 is applied to give a value within the appropriate range. This effectively extrapolates the erroneous cycle period back in time. Discarding an initial period of the time series data (see above) can also cause modulo 24 to be applied to a particular peak or trough CT time, if within the discarded data are peaks or troughs that occurred since the last ZT0. This would make it impossible to extrapolate CT0 forward due to the missing cycle periods. Applying modulo 24 effectively applies the present cycle period over the missing time block. This will of course give a slightly different answer than if all the time series data was retained, unless the model is perfectly entrained and the cycle period does not vary.

    The Cycle Periods, ZT and CT times calculated are expressed as Excel formulae, rather than literal values, thus the user can see exactly how they were calculated, and can alter this if required.

    Note
    • Columns “ZT Time” and “CT Time” will be empty if the entraining environment consisted only of constant dark, or constant low temperature. This is because in both cases there is no reference for calculating ZT time. However, for the purposes of the PRC, time zero will have been assumed to represent ZT0.
    • These columns will be missing if the model does not have a light-dark or a temperature cycle. In this case CT0 will be assumed to be at the end of the entraining period.

    Below this table will be an embedded chart of the time series values plotted alongside the environment. This will be for the entraining period, minus any initial period the user opted to discard, plus the additional constant conditions that were appended to create the PRC.

    Following this worksheet will be series of sheets for each time point-perturbation combination, called "Outputname, perturbation number at CTtime". These contain time series data in columns A to C as above, and a table of peak times. However, the time values only cover time of the first perturbation at CT0 onwards, as before this they would be identical to the control. Values for any model parameters that are perturbed appear in columns D onwards.

    Note that for these sheets, CT time of the peaks is not calculated, even though it may have been for the control run. This is because it would not be meaningful to calculate circadian time in this way when the system has been distorted by a perturbation. The circadian time of these peaks can be found from the phase shift values.


Tutorial Page 2

Tutorial Page 2 Model Parameters Files

<<Previous Next>>

  5. Opening a parameters file opens the Parameters Dialogue Box to display its contents and allow editing. This will look like this

    There is a tab for each of the model equations. On each tab you will see values for the initial level of the state described by the equation, in this case LHY mRNA, and the parameters which appear in this equation. These can be edited, but for now lets just leave then as they are and click "Close".

  6. Every simulation also requires an Environment File to run. Usually the environment represents the external conditions which the model is exposed to and which may change over time and affect how the state levels vary. As is the case for most models of circadian genetic networks, for this model the environment consists of the light-dark cycle. Click on the "Environment" tab of the file browser and you will see the name of the only environment file present at this stage appear in the browser window. This is also called "Default". Double click on its name to open it.


Tutorial Page 3

Tutorial Page 3 Environment Files

<<Previous Next>>

  7. Opening an environment file opens the Environment Dialogue Box to display its contents to allow editing. This will look like this

    Change the number of cycles to five. Leave the cycle as LD 12:12, save the file under the same name, overwriting when prompted, and click "Close".

  8. Now we are familiar with the essentials of simulation, lets run one by clicking the Experiments->Time Series->Simple menu item.


Tutorial Page 4

Tutorial Page 4 Simple Time Series Simulation

<<Previous Next>>

  9. An experiment is defined by moving through a series of forms which ask for input. You can move freely through these forms by clicking "Next" and "Back". The first form will look like this.

    Here you are asked to choose a parameters and an environment file to be used for this simulation. Leave both as they are as there probably won't be any other files to choose from at the moment. All you have to do is enter a name under which the generated Excel workbook will be saved. This can be any legal file name and you don't need to add the ".xls" extension.

  10. Click Next to bring up a form which we'll look at later. Ignore it for now and click Next again to bring up this form.

    Here you are asked to choose which model outputs you are interested in. Those selected will be imported into Excel and plotted against time. Select " 3 Level of nuclear LHY protein" and "6 Level of nuclear TOC1 protein". Also, check the "Plot all on same axes" box. This will produce a single plot of both proteins, making them easier to compare.

  11. Click Next to bring up the Integration form.

    Integration allows us to measure the area under a time series curve over specified blocks of time. This is useful in calculating mean protein levels over these time blocks and coincidence between proteins and light or darkness.

    This time we will measure the coincidence between TOC1 protein and light and dark. The drop down list will contain all the model states that were selected as outputs on the previous form. Change the drop down list to TOC1 and check the box next to it. This switches on integration of the selected output. The lists below should then become activated. Check the "White light cycle" box to choose to divide the time blocks for integration up by day and night.

  12. Thats all the information required. Just click "Finish" to launch the simulation and wait for it to complete.


Tutorial Page 5

Tutorial Page 5 Simple Time Series Simulation

<<Previous Next>>

  13. A progress bar will now appear. The simulation will probably take around 30 to 40 seconds, depending on the speed of your computer. When this is complete, click "OK", ensuring the "Launch results file" box is checked. This should launch Excel and open the workbook just created. We'll now look at its contents.

The first worksheet in the book is called "Title". This lists the name of the mode, the data and time it was run, and the contents of the parameters and environment files selected. This provides a complete definition of the simulation.

The next worksheet is called "Environment". This contains time values in column A and corresponding values for white light in column C. Column B contains the ZT time of each time value. In column E is a list of all the ZT0s that occurred.. These should be 0, 24, 48, 72 and 96 as white light was set to come on at time zero each day. Next to this is a table of on and off times for white light.

Next is a chart of the time series values of the two selected proteins and the light-dark cycle. It should look something like this.

The White light values are plotted on a secondary axis which is not shown, so the graph displays the relative changing values not the absolute values.

The next worksheet is called "cLn", as this is the shortened name for nuclear LHY protein used in the model. This contains time values, ZT times and protein levels in columns A to C. Next to this are tables of analysis for peak times and trough times that will look something like this.

The column "LDCycle" shows which day each peak or trough fell in. Next are the times that each peak and trough occurred, and the value of LHY protein at that time. Cycle period at each peak or trough is measured by taking the difference between this peak or trough and the previous one. Even when the model is properly entrained, cycle period is never exactly the same as the period of the entraining cycle due to numerical error in the equation solvers. ZT time is simply the difference between the peak or trough time and the previous ZT0. CT time is calculated only in periods of constant conditions, so does not apply to this simulation. If you click on these cells you will see that they are all Excel formulae so it is obvious exactly how each value was calculated. The idea of this is that users are free to alter these formulae if they don't agree with our methods of analysis.

The next worksheet is called "cTn" and contains the same data for TOC1 protein. However, we elected to integrate this output against the light-dark cycle so it contains an additional table of integration values which will look like this.

As you can see, there are sets of values for both days and nights. These are the measured areas under the curve for the corresponding time blocks. TOC1 is expressed predominantly at night, hence these values are much larger. The sections for constant conditions would be filled if there had been a period of DD or LL in the environment file. In this case time blocks would have been created based on the free running cycle period.

Below this table is a list of the actual values used for integration, and a chart of these values. The white markers on the chart indicate the boundaries of each time block. This chart does not actually tell us much as its values are just the time series values for TOC1, but if you integrate the coincidence between two or more outputs then it can be very useful to visualise the actual values used.

If you return to the Circadian Modelling main window and click on the "Results" tab of the file browser, you will see that the new workbook has appeared here. It can be opened from here by double clicking at any time in the future. The workbook has already been saved automatically so can be safely closed.

Now we are familiar with the basic operation we'll now simulate one of the most popular circadian experiments, a phase response curve.


Tutorial Page 6

Tutorial Page 6 Phase Response Curve

<<Previous Next>>

  1. Launch the Phase Response Curve module by clicking the Experiments->Phase Response Curve->Varying Time of Perturbation menu item. This will produce a dialogue box asking you to select parameters and environment files and enter an name for your simulation. As before just enter a name and click "Next". Again we'll ignore the form which appears for now. Just click "Next" again.

  2. That should bring up this form.

    Here you are asked to define the perturbation that will be used to produce the phase changes. This can be a perturbation to any of the model parameters, states, or the light-dark cycle. We'll keep it simple and just apply a light pulse. Click the "Environment" tab.

    "Value" is the background value light will have during the time period over which the pulse will be applied. "Perturbation" is the value light will have during the pulse. Enter the value "1".

    Leave the duration at 1 hour.

    The start time increment determines the number of pulses that will be applied and so the resolution of the PRC. Change this to 4 hours so make the simulation run quicker. This means that the pulses will be applied over 1 free running cycle period, every 4 circadian hours.

  3. Click Next to bring up the form below.

    Here you are asked to select a model output that is to be used as a measure of phase from the drop down list. We should not use LHY mRNA as this is a state that is affected directly by light. Change this to "4 cTm Level of TOC1 mRNA".

    The "Enter number of hours to track phase" value determines for how long after the pulse the simulation is allowed to move to its new phase before the PRC is generated.

    Check the "Retain time series data" box, as this will result in a more complete analysis of the data.

  4. Thats all the information required. Just click "Finish" to launch the simulation and wait for it to complete.


Tutorial Page 7

Tutorial Page 7 Phase Response Curve

<<Previous Next>>

  5. A progress bar will now appear. The simulation may take a minute or two to run the multiple simulations, depending on the speed of your computer. When this is complete, launch the results workbook.

The first worksheet in the book is again called "Title". This will be the same as before, except that information on the light pulse used to generate the PRC is included at the end.

The next worksheet is again "Environment". Note here that after the end of the 120 hours defined in our environment file, as requested, another 100 hours has been appended, with light having a value of zero through out this period. This is because this environment refers to the control run with no light pulse.

Next is a sheets called "PRC Data". This contains the table below.

This table displays the actual times of each light pulse, and their CT times. There are then blocks of data for two peak times. This is because we opted to append 100 hours over which to measure phase, and there were two suitable peaks found in this period in the control run. The top row of data shows these two times, 161.1 hours, and 187.3 hours. Below each of these are the times of the peak closest to the control in each of the runs with the light pulses. Phase change is calculated by subtracting these times from the control peak time and multiplying the result by 24 divided by the free running cycle period of the control run, in order to convert absolute hours to circadian hours. This method results in phase advances giving positive changes and phase delays giving negative changes, as is the convention in circadian biology. New phase is simply the phase change added to the CT time of the pulse. Modulo 24 is applied to this to ensure all values are in the appropriate range of zero to less than 24. Again all values are Excel formulae so the exact calculations used can be seen.

Below this table are a series of time series plots of each pulsed run plotted alongside the pulse and the control run.

Next comes a chart called "Phase Shifts". This is a plot of phase change versus peak number, with a series for each pulse time. This would be useful if you were interested in tracking how long it takes for the model to reach a new stable phase after the light pulse.

Next you will see the actual phase response curve and the phase transition curve, which are plots of phase change versus CT time of pulse and new phase versus old phase respectively. Each of these is plotted using the last suitable peak in the control run, which in this case is peak two. The PRC should look like this.

Next there is a worksheet called "cTm, no perturbation". This contains time series values, analysis of peak times and an embedded chart for the control run. Note that this time there are values present for CT time for the DD period from 120 to 220 hours. CT time is measured by extrapolating the last ZT0 time forward, using the free running cycle period, to just before the peak in question, and converting the time difference to circadian hours. Again this is an Excel formulae, which you can alter if you don't agree with our calculations.

After this come a series of sheets of time series values for the runs with the different light pulses. These only cover the period from the first light pulse onwards, as prior to this they are all identical to the control run. Light values appear alongside the mRNA levels, showing just where the pulses occurred.

When you have finished looking at the workbook it is safe to close it as it has already been saved. It will again appear under the "Results" tab of the Circadian Modelling main window, from where it can be opened again when required.

Circadian modelling also allows the production of PRCs with differing sizes of perturbation, and 3D PRCs where both time and size are varied. Next though we will look at another common circadian experiment, a fluence response experiment.


Tutorial Page 8

Tutorial Page 8 Fluence Response Simulation

<<Previous Next>>

A fluence response experiment involves letting an organism free run under constant conditions of varying light intensity and comparing the free running cycle period under the different intensities. Therefore we need to run multiple time series simulations, produce some sort of summary table showing the effect of intensity on period, and also plot corresponding outputs on the same axes.

  1. The first thing we need to do is create an environment file of LL. Click the "Environment" tab on the main window and open the default environment file. Set the "On" time to zero and "Off" time to "24". When these values are entered the black and white bar should turn all white (assuming the cycle period is set to 24 hours. Set it if it is not). Save this file as "LL" and then close the dialogue box.

  2. One way of running this experiment is to click the Experiments->Time Series->Compare Simulations->Vary Parameters Freely menu item. This will produce a dialogue box asking you to select parameters and environment files and enter a name for your simulation. Make sure the environment file is set to "LL", enter a name and click "Next". Again we'll ignore the form which appears for now. Just click "Next" again.

    In this module we are saying that we want to run the same simulation with the same environment and parameters files a number of times. We are given the opportunity though to vary any of the values in these files between runs, in order to see what effect this will have on the output. This form allows us just to choose which parameters we want to vary.

    We are interested in the brightness of the light. Select the "Environment" tab to view the parameters defined in the environment file. Check the box next to "White On value (Ion)" and click "Next".

  3. This form will appear.

    Here you are asked to define the values that each of the selected parameters will take on each run. We selected only one so we have only one appearing in the data grid. The value in column "Default" is the value in the selected environment file. This value will be used in every run unless it is overridden in this form. You can do this by entering values in the Value columns.

    First enter zero for Value 1 and "0.5" for Value 2. We would like more repeats than this so click "Add a new set of values" to add another column to the grid. Do this twice more so we have five Value columns. We will therefore repeat this simulation five times.

    Enter "1" for Value 3. In fact you could leave this box empty as it is the same as the default value. Enter "2" for Value 4 and "3" for Value 5.

  4. Click Next to bring up a form we will ignore for now. Click Next again to bring up this form.

    Here we are asked to select the model outputs we are interested in analysing. Check "4 Level of TOC1 mRNA".

    Ensure the "Retain the time series data" box is checked and click Next.

  5. You will now see the integration dialogue box again. Check the box next to the drop down list to integrate the output. We won't bother checking the "White light cycle" box this time as the cycle is constant. TOC1 will be integrated in time blocks of one free running cycle period.
  6. Thats all the information required. Just click "Finish" to launch the simulation and wait for it to complete.


Tutorial Page 9

Tutorial Page 9 Fluence Response Simulation

<<Previous Next>>

  7. A progress bar will now appear. The simulation will probably take a minute or so, depending on the speed of your computer. When this is complete, launch the results workbook.

The first worksheet in the book is again called "Title". This will be the same as before, except that information on the parameter variations between runs is appended at the bottom.

The next worksheet is called "Summary Data". This contains a table comparing how various aspects the output vary between runs. It will look like this.

As you can see, the effect of varying the light intensity on period, amplitude, peak and trough phase and area under the curve for each period is shown. These values represent the values for the final cycle period for each run, except integration which is the next to last. This is because the final integration block is not always the same length as earlier ones, depending on the precise length of the simulation. Integration values appear in the column "Free Running Period" because we elected not to integrate against the light cycle. If we had done so then the same values would appear in the "Constant Light" column. Again these values are all Excel formulae.

Next is a sheet called "Summary Charts" which contains plots of this data. For example, the effect on light intensity on free running period should look something like this

The next worksheet is called "Environment 1". This contains all the light values for the first run of the simluation. These will be all zeros.

The next worksheet is called "cTm, Run 1". This contains the time series values for the selected output. As before for the simple time series experiment there is a table of peak and trough time values and analysis, a table of integration values, and an embedded plot of the integrated data.

There will be a corresponding pair of these last two sheets for all five runs.

At the end of the book there are two charts. The first "Chart - cTm" is a plot of the five sets of time series values all on the same axes. It should look something like this.

The second chart "Chart - cTM Peaks" is a plot of CT time of each peak time, with a separate series for each run. This is produced because it was possible to calculate CT times in this experiment due to the environment being constant conditions. It should look like this.

Measuring circadian time of the peak is useful because any change of peak time relative to the cycle period may indicate a change in shape of the waveform.

That concludes this experiment. When you have finished looking at the workbook it is safe to close it as it has already been saved. It will again appear under the "Results" tab of the Circadian Modelling main window, from where it can be opened again when required.

Next we'll take a look at mutations.


Tutorial Page 10

Tutorial Page 10 Simulating Mutations

<<Previous Next>>

In this experiment we will look at simulating mutations by manipulating model parameters. We will run the mutation alongside the wild type and compare the results.

  1. The first thing we need to do is to create the mutation. We could simply edit a parameters file directly, but there is a convenient shortcut. Click the "Mutations" tab of the file browser. Right click the file view area and select New from the popup menu. This will launch the mutations dialogue box.

    The tabs represent possible targets for mutation, and consist of gene promotors and proteins. On each tab is a list of possible ways to mutate that target. These lists are not exhaustive, but are just the ones I managed to think up when writing the software. Any other mutation can be created by simply editing the parameters file directly.

    We are going to add an constitutive copy of the X gene, so click the "X promotor" tab.

    Check the "Add a Constitutive Over-Expressor" box to activate this mutation. The value in the box is the rate of expression that this gene will have. Lets leave it at "1".

    When adding an over-expressor gene, you may if you wish, knock out the native regulated copy of the gene. This not necessary but we will do it here as an example. Check the "Knockout Mutation" box.

    Now click "Save" and save the mutations file under the name "X ox", and click "Close".

  2. So far we have just defined a combination of two mutations. We haven't actually applied them yet. We must do this now by applying the mutations file to a parameters set. Click the "Parameters" tab and open the parameters file "Default". Click "Mutate" and choose the file "X ox" we just created from the list that appears and click "OK".

    The parameters form will now look like this. The parameters cXm and n3 will be changed to zero and coloured grey. This is the result of the knockout mutation. The colour is just to indicate that they have been affected by the mutation. You can still edit them further if you wish.

    Notice also that the "Activate constitutive gene" box is checked and this has resulted in the appearance of a new tab called "X ox".

    Click on this tab and you will see the parameters relating to the over-expresser gene that control its transcription and translation.

    Now save the file under the name "X ox" and close the form.

  3. We could now run the mutation as it is, but it might be more interesting to cause the over-expresser to be switched on part way through a simulation. This also introduces us to the concept of parameter perturbations. The parameters are not after all constants. They can have their values altered at defined time during a simulation, giving enormous flexibility. To see how this works click on the "Perturbations" tab. Right click on the file view area and select New from the popup menu. This launches the perturbations dialogue box.

    We want to perturb the rate of expression of the constitutive X gene we have added by setting its rate to zero for an initial period.

    This is a parameter not a state, so click on the "Parameters" tab. Select "n4ox Constitutive X gene expression level" from the drop down list at the top (it will be somewhere near the bottom of the list).

    Set the "Perturb its value by" list to "Setting to", and the values next to it to "0" for "120" hours. The other values you can see determine when the perturbation will begin. Leave them as they are and it will begin at the start of the simulation. Click the "Add" button and the details just entered will appear in the grid below.

    Click "Save" and save the file as "X ox off" and click "Close".

  4. The final thing we need to do is create an environment file long enough to apply this mutation. Click the "Environment" tab, open the file "Default" and change the number of cycles to 10. The cycle itself should still be LD 12:12. Save the file.

  5. We are now ready to run the mutation. It could be run as a simple time series experiment, but it might be more interesting to run it alongside the wild type and compare the results. Click the Experiments->Time Series->Compare Simulations->Vary Input File menu item. This will produce the dialogue box below.

    In this module we are saying that we want to run a number of simulations with different input files and compare the results. We choose the files for each run with this form.

    In the "Run 1" column change the environment file to "Default". In the "Run 2" column change the parameters file to "X ox" to use our mutation, change the environment file to "Default", and apply our perturbation by setting the perturbations file to "X ox off".

    You can see from this form that unlike parameters and environment files, perturbations files are optional. The default is always "-none-".

    Enter a name for the workbook and click "Next".

  6. This form will appear. This is the form we have been ignoring up until now.

    Perturbations files define perturbation times in terms of the environment cycle, not as absolute times. For this reason, perturbation times are not generated until a perturbations file is combined with an environment file. This has now been done and the results are displayed on this form.

    Change the "Select run number" box to "Run 2" (Run 1 has no perturbations to see), and the tab to "Parameters". The grids now show the perturbations that will be applied during this run. As you can see, the parameters perturbation will be applied from zero to 120 hours to parameter n4ox. If you return to the "States" tab you will se that this grid is empty because there are no state perturbations.

    Of course in this example as the perturbation was applied at the very start then it makes no difference to the time which environment file is selected.

  7. Click Next to bring up this form.

    Here we are asked to select the model outputs we are interested in analysing. Check "4 Level of TOC1 mRNA", "7 Level of X mRNA", and "48 Level of X mRNA from constitutive gene".

    Ensure the "Retain the time series data" box is checked and click Next.

  8. You will now see the integration dialogue box again. We won't bother integrating this time. Just click "Finish" to launch the simulation and wait for it to complete.


Tutorial Page 11

Tutorial Page 11 Simulating Mutations

<<Previous Next>>

  9. The simulation will probably take a minute or two, depending on the speed of your computer. When this is complete, launch the results workbook.

The first worksheet in the book is again called "Title". This will list the contents of all the files used for each of the runs.

The next worksheet is called "Summary Data". This contains three tables, one for each output. comparing how various aspects the output vary between runs.

As you can see, the effect of varying the input files on period, amplitude, peak and trough phase are all shown. There is no integration this time as we did not select this option. Again these values represent the values for the final cycle period for each run, and these values are all Excel formulae.

You can see that the data for level of X mRNA from constitutive gene is meaningless. This is because this output does not oscillate. The same applies to level of X mRNA on run 2 as this native gene is knocked out.

Next is a sheet called "Summary Charts" which contains plots of this data, one row of graphs for each output. These do not really show very much this time, but we are not really interested in this. In this experiment we are more interested in the time series.

The next worksheet is called "Environment 1". This contains all the light values for the first run of the simulation.

The next worksheet is called "cXmox, Run 1". This contains the time series values for X mRNA from the constitutive gene. This was not switched on on the first run so consists of all zeros.

Next is a worksheet called "cXm, Run 1". This contains the time series values for X mRNA from the native gene in run 1, the wild type experiment. Similarly there is a worksheet called "cTm, Run 1" for TOC1 mRNA from run1.

Now come the worksheets for the second run, the mutation. "Environment 2" is the same as "Environment 1" as the same environment file was used in both runs. "cXmox, Run 2" shows how the level of mRNA from the over-expressor gene is zero for the first 120 hours, and then rises rapidly when the gene is switched on, and levels off as degradation equals production. The embedded chart should look like this.

"cXm, Run 2" is the level of X mRNA from the native gene. This is all zeros as this gene is knocked out by the mutation.

"cTm, Run 2" is the level of TOC1 mRNA. This shows a distorted time series that is damping for the first 120 hours. This is is due to the knockout of the X gene. However, when the constitutive X gene is switched on, TOC1 levels falls rapidly to zero.

Next is a chart called "Chart - Perturbations Run 2". Whenever a perturbation is applied to a model parameter, in this case the level of expression of the constitutive gene, n4ox, a chart will be plotted of its changing value alongside the environment cycle. This is just to confirm that its value changed during the simulation in the way that was intended. It can be seen that its value switched from zero to one at 120 hours as we intended. The next worksheet just contains the source data for this chart.

At the end of the book there are three charts, one for each output. These are plots of the time series for both runs on the same axes. For example, the plot for TOC1 mRNA is show below.

Blue is the wild type, and purple the mutation. The distortion of the level of TOC1 due to the X gene knockout can be clearly seen. It is apparent here that the period of the oscillation is reduced by the mutation.

The chart for X mRNA from the native gene simply shows the level being zero for the second run, and the chart for X mRNA from the constitutive gene shows that an initial level of zero rises rapidly at 120 hours and levels off on the second run, whilst remaining flat on the first.

That concludes this experiment. When you have finished looking at the workbook it is safe to close it as it has already been saved. It will again appear under the "Results" tab of the Circadian Modelling main window, from where it can be opened again when required.

For our final tutorial we will take another look at perturbations, look at creating a more complex environment, and see how flexible Circadian Modelling can be.


Tutorial Page 12

Tutorial Page 12 Applying Parameter Perturbations

<<Previous Next>>

Applying perturbations to the model and environment parameters is an extremely powerful tool, allowing the simulation of almost any experiment. In the last tutorial we applied a simple one-off perturbation to switch on a gene at a defined time. This time we are going to see how easy it is to apply multiple perturbations at defined times. Say you wished to simulate the effect of an external factor other than the environment on the circadian system, for example a hormone or an artificial drug. First you must decide how this factor's presence will affect the model. Generally this will be by altering one of the model parameters, for example a drug that switched on a gene could raise the parameter representing its maximum transcription rate, or a drug that binds to a protein and prevents it from doing its job could set the appropriate parameters to zero. It would be very easy to simulate a single application in a similar experiment to the last tutorial, but an interesting experiment might then be to see if the system can be entrained by repeated regular application of this external factor.

  1. The first thing we will do is create a suitable environment file for this simulation. Click the "Environment" tab and open the file "Default". As we are entraining our model with perturbations, we don't want the light-dark cycle interfering. Set both "On" and "Off" values to zero to create DD. The bar should then turn all black. Set the number of days to five. Now click the "Insert Copy" button which is just above the tab saying "Regime 1". You will see that another tab "Regime 2" has appeared. What this means is that after the five days defined in regime one are applied, then the days defined here will be applied. This is the period when we will begin to apply our perturbations. Click "Insert Copy" again to create a third regime. This time however, change the cycle period to 28 hours. We'll see why in a minute.

    The concept of multiple regimes allows us to apply as complex an environment cycle as we wish. We can simulate almost any combination of light-dark values. Most commonly we will want to apply an LD cycle which then switches to constant conditions. We are not doing this here though, as all our regimes are DD. What we are doing is using the environment to provide us with reference points in time for applying out repeated perturbation.

    Save the file as "Multi Regimes" and close the form.

  2. Now we must create a suitable perturbations file. Click on the "Perturbations" tab. Right click on the file view area and select New from the popup menu to launch the perturbations dialogue box. We have already looked at perturbing parameters, so lets imagine our external factor causes an immediate boost levels of TOC1 mRNA and we can look at perturbing model states.

    Select the "States" tab and select "cTm Level of TOC1 mRNA" from the drop down list.

    Set the other controls as shown here.

    There are three ways to define the size of a perturbation: setting to an absolute value, adding a value to the existing value, or multiplying the existing value by a factor. In the case of a state we cannot know what the existing value will be at the moment of the perturbation of course. Set the "Perturb its value by" list to "Adding" and leave the value to add as "1". (It is possible to add a negative value to remove some RNA or protein , but the equation solver ensures that its level never falls below zero of course.)

    Set "At" to "0" and "hours from start" to "Light-Dark cycle" Regime "2" Cycle "1". This defines the time of the perturbation as being at the start of the first day of the second regime.

    Now to cause the perturbation to be repeated. Check the "Repeat at" box and set the drop down list to "same time in subsequent LD cycles". Set the max repeat number to "10". This will cause the perturbation to be repeated at time zero on every subsequent new cycle, up to a maximum of ten times if the simulation is long enough. Remember that we changed the length of the cycle at the start of Regime 3, and so the frequency of our perturbations will alter at this point. Thus we will investigate if it is possible to entrain the system to this different period.

    There is another option, to repeat perturbations at the same ZT time each cycle. This is slightly different as it depends on the time of lights on rather than the start of the cycle, but we won't use this option here.

    Now click "Add" and the details should appear in the grid as shown. Save the file as "TOC1 boost" and close the form.

  3. We are now ready to run the simulation. Click the Experiments->Time Series->Simple menu item. This will produce the dialogue box that requests us to select parameters and environment files. Change the environment file to "Multi Regimes", enter a name for the workbook, and click "Next".

  4. This brings up the form we have ignored before.

    Here you are asked to choose a perturbations file to use in the experiment. Select "TOC1 boost" from the drop down list and select the "States" tab. You should then see all the calculated times when the perturbations will be applied.

    Note how the first six from 120 to 240 hours are applied at 24 hour intervals, but after this the interval becomes 28 hours.

  5. Click "Next" to bring up the outputs form. Select "1 Level of LHY mRNA" and "4 Level of TOC1 mRNA" and click "Next".

  6. This brings up the integration form. We won't integrate this time so just click "Finish" to launch the simulation and wait for it to complete.


Tutorial Page 13

Tutorial Page 13 Applying Parameter Perturbations

<<Previous

  7. The simulation will probably take around 30 seconds, depending on the speed of your computer. When this is complete, launch the results workbook.

The first worksheet in the book is again called "Title". This will list the contents of the parameters and environment file, and the perturbation times.

The next worksheet is called "Environment". This contains the time series for the light dark cycle. Note that there are no ZT times this time. This is because the entire simulation was DD so there was no reference for ZT0.

Next is the chart of LHY mRNA values, "Chart - cLm". It should look something like this.

Next, the worksheet "cLm" contains the time series values and peak and trough time analysis.

Note that the free running period in regime one, before the perturbations are applied, is around 25.7 hours (peak at 104 hours). By the end of the second regime it is down to 24 hours (peak at 228 hours), due to the repeated pulses of TOC1 every 24 hours. By the end of regime three it is up to 27.2 hours (peak at 360 hours), due to the pulses being applied every 28 hours in this regime.

Next is a chart of the time series values for TOC1 that should look something like this.

Note the spikes when each perturbation is applied. The final worksheet "cTm" contains the time series values and peak and trough time analysis. This is less useful for cycle period analysis because the spike caused by the perturbation causes double peaks during each cycle period in regime three. It would require a small amount of editing of the data table to remove this problem.

When you have finished looking at the workbook it is safe to close it as it has already been saved. It will again appear under the "Results" tab of the Circadian Modelling main window, from where it can be opened again when required.

That concludes this tutorial. Click here for a more detailed exploration of Circadian Modelling. We hope you find this software useful and would welcome any feedback on our website www.amillar.org.

<<Previous